structure Gl =
struct

open Gl_

(* AccumOp *)
val gl_ACCUM = def_GL_ACCUM()
val gl_LOAD = def_GL_LOAD()
val gl_RETURN = def_GL_RETURN()
val gl_MULT = def_GL_MULT()
val gl_ADD = def_GL_ADD()
type accumop
	= ACCUM 
	| LOAD
	| RETURN
	| MULT
	| ADD 
fun accumop_to_int ACCUM  = gl_ACCUM 
|	accumop_to_int LOAD   = gl_LOAD
|	accumop_to_int RETURN = gl_RETURN
|	accumop_to_int MULT   = gl_MULT
|	accumop_to_int ADD    = gl_ADD
(* Alpha/Depth/Stencil Function *)
val gl_NEVER = def_GL_NEVER()
val gl_LESS = def_GL_LESS()
val gl_EQUAL = def_GL_EQUAL()
val gl_LEQUAL = def_GL_LEQUAL()
val gl_GREATER = def_GL_GREATER()
val gl_NOTEQUAL = def_GL_NOTEQUAL()
val gl_GEQUAL = def_GL_GEQUAL()
val gl_ALWAYS = def_GL_ALWAYS()
type asdfunc
	= NEVER
	| LESS
	| EQUAL
	| LEQUAL
	| GREATER
	| NOTEQUAL
	| GEQUAL
	| ALWAYS
fun asdfunc_to_int NEVER    = gl_NEVER
|	asdfunc_to_int LESS     = gl_LESS
|	asdfunc_to_int EQUAL    = gl_EQUAL
|	asdfunc_to_int LEQUAL   = gl_LEQUAL
|	asdfunc_to_int GREATER  = gl_GREATER
|	asdfunc_to_int NOTEQUAL = gl_NOTEQUAL
|	asdfunc_to_int GEQUAL   = gl_GEQUAL
|	asdfunc_to_int ALWAYS   = gl_ALWAYS
(* AttribMask *)
val gl_CURRENT_BIT = def_GL_CURRENT_BIT()
val gl_POINT_BIT = def_GL_POINT_BIT()
val gl_LINE_BIT = def_GL_LINE_BIT()
val gl_POLYGON_BIT = def_GL_POLYGON_BIT()
val gl_POLYGON_STIPPLE_BIT = def_GL_POLYGON_STIPPLE_BIT()
val gl_PIXEL_MODE_BIT = def_GL_PIXEL_MODE_BIT()
val gl_LIGHTING_BIT = def_GL_LIGHTING_BIT()
val gl_FOG_BIT = def_GL_FOG_BIT()
val gl_DEPTH_BUFFER_BIT = def_GL_DEPTH_BUFFER_BIT()
val gl_ACCUM_BUFFER_BIT = def_GL_ACCUM_BUFFER_BIT()
val gl_STENCIL_BUFFER_BIT = def_GL_STENCIL_BUFFER_BIT()
val gl_VIEWPORT_BIT = def_GL_VIEWPORT_BIT()
val gl_TRANSFORM_BIT = def_GL_TRANSFORM_BIT()
val gl_ENABLE_BIT = def_GL_ENABLE_BIT()
val gl_COLOR_BUFFER_BIT = def_GL_COLOR_BUFFER_BIT()
val gl_HINT_BIT = def_GL_HINT_BIT()
val gl_EVAL_BIT = def_GL_EVAL_BIT()
val gl_LIST_BIT = def_GL_LIST_BIT()
val gl_TEXTURE_BIT = def_GL_TEXTURE_BIT()
val gl_SCISSOR_BIT = def_GL_SCISSOR_BIT()
val gl_ALL_ATTRIB_BITS = def_GL_ALL_ATTRIB_BITS()
type attribmask
	= CURRENT_BIT
	| POINT_BIT
	| LINE_BIT
	| POLYGON_BIT
	| POLYGON_STIPPLE_BIT
	| PIXEL_MODE_BIT
	| LIGHTING_BIT
	| FOG_BIT
	| DEPTH_BUFFER_BIT
	| ACCUM_BUFFER_BIT
	| STENCIL_BUFFER_BIT
	| VIEWPORT_BIT
	| TRANSFORM_BIT
	| ENABLE_BIT
	| COLOR_BUFFER_BIT
	| HINT_BIT
	| EVAL_BIT
	| LIST_BIT
	| TEXTURE_BIT
	| SCISSOR_BIT
	| ALL_ATTRIB_BITS
fun attribmask_to_int CURRENT_BIT = gl_CURRENT_BIT
|	attribmask_to_int POINT_BIT = gl_POINT_BIT
|	attribmask_to_int LINE_BIT = gl_LINE_BIT
|	attribmask_to_int POLYGON_BIT = gl_POLYGON_BIT
|	attribmask_to_int POLYGON_STIPPLE_BIT = gl_POLYGON_STIPPLE_BIT
|	attribmask_to_int PIXEL_MODE_BIT = gl_PIXEL_MODE_BIT
|	attribmask_to_int LIGHTING_BIT = gl_LIGHTING_BIT
|	attribmask_to_int FOG_BIT = gl_FOG_BIT
|	attribmask_to_int DEPTH_BUFFER_BIT = gl_DEPTH_BUFFER_BIT
|	attribmask_to_int ACCUM_BUFFER_BIT = gl_ACCUM_BUFFER_BIT
|	attribmask_to_int STENCIL_BUFFER_BIT = gl_STENCIL_BUFFER_BIT
|	attribmask_to_int VIEWPORT_BIT = gl_VIEWPORT_BIT
|	attribmask_to_int TRANSFORM_BIT = gl_TRANSFORM_BIT
|	attribmask_to_int ENABLE_BIT = gl_ENABLE_BIT
|	attribmask_to_int COLOR_BUFFER_BIT = gl_COLOR_BUFFER_BIT
|	attribmask_to_int HINT_BIT = gl_HINT_BIT
|	attribmask_to_int EVAL_BIT = gl_EVAL_BIT
|	attribmask_to_int LIST_BIT = gl_LIST_BIT
|	attribmask_to_int TEXTURE_BIT = gl_TEXTURE_BIT
|	attribmask_to_int SCISSOR_BIT = gl_SCISSOR_BIT
|	attribmask_to_int ALL_ATTRIB_BITS = gl_ALL_ATTRIB_BITS
(* BeginMode *)
val gl_POINTS = def_GL_POINTS()
val gl_LINES = def_GL_LINES()
val gl_LINE_LOOP = def_GL_LINE_LOOP()
val gl_LINE_STRIP = def_GL_LINE_STRIP()
val gl_TRIANGLES = def_GL_TRIANGLES()
val gl_TRIANGLE_STRIP = def_GL_TRIANGLE_STRIP()
val gl_TRIANGLE_FAN = def_GL_TRIANGLE_FAN()
val gl_QUADS = def_GL_QUADS()
val gl_QUAD_STRIP = def_GL_QUAD_STRIP()
val gl_POLYGON = def_GL_POLYGON()
type beginmode
	= POINTS
	| LINES
	| LINE_LOOP
	| LINE_STRIP
	| TRIANGLES
	| TRIANGLE_STRIP
	| TRIANGLE_FAN
	| QUADS
	| QUAD_STRIP
	| POLYGON
fun beginmode_to_int POINTS = gl_POINTS
|	beginmode_to_int LINES = gl_LINES
|	beginmode_to_int LINE_LOOP = gl_LINE_LOOP
|	beginmode_to_int LINE_STRIP = gl_LINE_STRIP
|	beginmode_to_int TRIANGLES = gl_TRIANGLES
|	beginmode_to_int TRIANGLE_STRIP = gl_TRIANGLE_STRIP
|	beginmode_to_int TRIANGLE_FAN = gl_TRIANGLE_FAN
|	beginmode_to_int QUADS = gl_QUADS
|	beginmode_to_int QUAD_STRIP = gl_QUAD_STRIP
|	beginmode_to_int POLYGON = gl_POLYGON
(* BlendingFactorDest *)
val gl_ZERO = def_GL_ZERO()
val gl_ONE = def_GL_ONE()
val gl_SRC_COLOR = def_GL_SRC_COLOR()
val gl_ONE_MINUS_SRC_COLOR = def_GL_ONE_MINUS_SRC_COLOR()
val gl_SRC_ALPHA = def_GL_SRC_ALPHA()
val gl_ONE_MINUS_SRC_ALPHA = def_GL_ONE_MINUS_SRC_ALPHA()
val gl_DST_ALPHA = def_GL_DST_ALPHA()
val gl_ONE_MINUS_DST_ALPHA = def_GL_ONE_MINUS_DST_ALPHA()
(* BlendingFactorSrc *)
(*      GL_ZERO *)
(*      GL_ONE *)
val gl_DST_COLOR = def_GL_DST_COLOR()
val gl_ONE_MINUS_DST_COLOR = def_GL_ONE_MINUS_DST_COLOR()
val gl_SRC_ALPHA_SATURATE = def_GL_SRC_ALPHA_SATURATE()
(*      GL_SRC_ALPHA *)
(*      GL_ONE_MINUS_SRC_ALPHA *)
(*      GL_DST_ALPHA *)
(*      GL_ONE_MINUS_DST_ALPHA *)
type blendfactor
	= ZERO
	| ONE
	| SRC_COLOR
	| DST_COLOR
	| ONE_MINUS_SRC_COLOR
	| ONE_MINUS_DST_COLOR
	| SRC_ALPHA
	| DST_ALPHA
	| ONE_MINUS_SRC_ALPHA
	| ONE_MINUS_DST_ALPHA
	| SRC_ALAPH_SATURATE
fun blendfactor_to_int ZERO = gl_ZERO
|	blendfactor_to_int ONE = gl_ONE
|	blendfactor_to_int SRC_COLOR = gl_SRC_COLOR
|	blendfactor_to_int DST_COLOR = gl_DST_COLOR
|	blendfactor_to_int ONE_MINUS_SRC_COLOR = gl_ONE_MINUS_SRC_COLOR
|	blendfactor_to_int ONE_MINUS_DST_COLOR = gl_ONE_MINUS_DST_COLOR
|	blendfactor_to_int SRC_ALPHA = gl_SRC_ALPHA
|	blendfactor_to_int DST_ALPHA = gl_DST_ALPHA
|	blendfactor_to_int ONE_MINUS_SRC_ALPHA = gl_ONE_MINUS_SRC_ALPHA
|	blendfactor_to_int ONE_MINUS_DST_ALPHA = gl_ONE_MINUS_DST_ALPHA
|	blendfactor_to_int SRC_ALAPH_SATURATE = gl_SRC_ALPHA_SATURATE
(* ClipPlaneName *)
val gl_CLIP_PLANE0 = def_GL_CLIP_PLANE0()
val gl_CLIP_PLANE1 = def_GL_CLIP_PLANE1()
val gl_CLIP_PLANE2 = def_GL_CLIP_PLANE2()
val gl_CLIP_PLANE3 = def_GL_CLIP_PLANE3()
val gl_CLIP_PLANE4 = def_GL_CLIP_PLANE4()
val gl_CLIP_PLANE5 = def_GL_CLIP_PLANE5()
type planename
	= PLANE0
	| PLANE1
	| PLANE2
	| PLANE3
	| PLANE4
	| PLANE5
fun planename_to_int PLANE0 = gl_CLIP_PLANE0
|	planename_to_int PLANE1 = gl_CLIP_PLANE1
|	planename_to_int PLANE2 = gl_CLIP_PLANE2
|	planename_to_int PLANE3 = gl_CLIP_PLANE3
|	planename_to_int PLANE4 = gl_CLIP_PLANE4
|	planename_to_int PLANE5 = gl_CLIP_PLANE5
(* DataType *)
val gl_BYTE = def_GL_BYTE()
val gl_UNSIGNED_BYTE = def_GL_UNSIGNED_BYTE()
val gl_SHORT = def_GL_SHORT()
val gl_UNSIGNED_SHORT = def_GL_UNSIGNED_SHORT()
val gl_INT = def_GL_INT()
val gl_UNSIGNED_INT = def_GL_UNSIGNED_INT()
val gl_FLOAT = def_GL_FLOAT()
val gl_2_BYTES = def_GL_2_BYTES()
val gl_3_BYTES = def_GL_3_BYTES()
val gl_4_BYTES = def_GL_4_BYTES()
val gl_DOUBLE = def_GL_DOUBLE()
type datatype
	= BYTE
	| UNSIGNED_BYTE
	| SHORT
	| UNSIGNED_SHORT
	| INT
	| UNSIGNED_INT
	| FLOAT
	| _2_BYTES
	| _3_BYTES
	| _4_BYTES
	| DOUBLE
fun datatype_to_int BYTE = gl_BYTE
|	datatype_to_int UNSIGNED_BYTE = gl_UNSIGNED_BYTE
|	datatype_to_int SHORT = gl_SHORT
|	datatype_to_int UNSIGNED_SHORT = gl_UNSIGNED_SHORT
|	datatype_to_int INT = gl_INT
|	datatype_to_int UNSIGNED_INT = gl_UNSIGNED_INT
|	datatype_to_int FLOAT = gl_FLOAT
|	datatype_to_int _2_BYTES = gl_2_BYTES
|	datatype_to_int _3_BYTES = gl_3_BYTES
|	datatype_to_int _4_BYTES = gl_4_BYTES
|	datatype_to_int DOUBLE = gl_DOUBLE
(* DrawBufferMode *)
val gl_NONE = def_GL_NONE()
val gl_FRONT_LEFT = def_GL_FRONT_LEFT()
val gl_FRONT_RIGHT = def_GL_FRONT_RIGHT()
val gl_BACK_LEFT = def_GL_BACK_LEFT()
val gl_BACK_RIGHT = def_GL_BACK_RIGHT()
val gl_FRONT = def_GL_FRONT()
val gl_BACK = def_GL_BACK()
val gl_LEFT = def_GL_LEFT()
val gl_RIGHT = def_GL_RIGHT()
val gl_FRONT_AND_BACK = def_GL_FRONT_AND_BACK()
val gl_AUX0 = def_GL_AUX0()
val gl_AUX1 = def_GL_AUX1()
val gl_AUX2 = def_GL_AUX2()
val gl_AUX3 = def_GL_AUX3()
type buffermode
	= NONE
	| FRONT_LEFT
	| FRONT_RIGHT
	| BACK_LEFT
	| BACK_RIGHT
	| FRONT
	| BACK
	| LEFT
	| RIGHT
	| FRONT_AND_BACK
	| AUX0
	| AUX1
	| AUX2
	| AUX3
fun buffermode_to_int NONE = gl_NONE
|	buffermode_to_int FRONT_LEFT = gl_FRONT_LEFT
|	buffermode_to_int FRONT_RIGHT = gl_FRONT_RIGHT
|	buffermode_to_int BACK_LEFT = gl_BACK_LEFT
|	buffermode_to_int BACK_RIGHT = gl_BACK_RIGHT
|	buffermode_to_int FRONT = gl_FRONT
|	buffermode_to_int BACK = gl_BACK
|	buffermode_to_int LEFT = gl_LEFT
|	buffermode_to_int RIGHT = gl_RIGHT
|	buffermode_to_int FRONT_AND_BACK = gl_FRONT_AND_BACK
|	buffermode_to_int AUX0 = gl_AUX0
|	buffermode_to_int AUX1 = gl_AUX1
|	buffermode_to_int AUX2 = gl_AUX2
|	buffermode_to_int AUX3 = gl_AUX3
(* ErrorCode *)
val gl_NO_ERROR = def_GL_NO_ERROR()
val gl_INVALID_ENUM = def_GL_INVALID_ENUM()
val gl_INVALID_VALUE = def_GL_INVALID_VALUE()
val gl_INVALID_OPERATION = def_GL_INVALID_OPERATION()
val gl_STACK_OVERFLOW = def_GL_STACK_OVERFLOW()
val gl_STACK_UNDERFLOW = def_GL_STACK_UNDERFLOW()
val gl_OUT_OF_MEMORY = def_GL_OUT_OF_MEMORY()
type errorcode
	= NO_ERROR
	| INVALID_ENUM
	| INVALID_VALUE
	| INVALID_OPERATION
	| STACK_OVERFLOW
	| STACK_UNDERFLOW
	| OUT_OF_MEMORY
fun errorcode_to_int NO_ERROR = gl_NO_ERROR
|	errorcode_to_int INVALID_ENUM = gl_INVALID_ENUM
|	errorcode_to_int INVALID_VALUE = gl_INVALID_VALUE
|	errorcode_to_int INVALID_OPERATION = gl_INVALID_OPERATION
|	errorcode_to_int STACK_OVERFLOW = gl_STACK_OVERFLOW
|	errorcode_to_int STACK_UNDERFLOW = gl_STACK_UNDERFLOW
|	errorcode_to_int OUT_OF_MEMORY = gl_OUT_OF_MEMORY
fun errorcode_of_int n =
	if n=gl_NO_ERROR then NO_ERROR else
	if n=gl_INVALID_ENUM then INVALID_ENUM else
	if n=gl_INVALID_VALUE then INVALID_VALUE else
	if n=gl_INVALID_OPERATION then INVALID_OPERATION else
	if n=gl_STACK_OVERFLOW then STACK_OVERFLOW else
	if n=gl_STACK_UNDERFLOW then STACK_UNDERFLOW else
	if n=gl_OUT_OF_MEMORY then OUT_OF_MEMORY else
	raise Failure "errorcode_of_int"
(* FeedBackMode *)
val gl_2D = def_GL_2D()
val gl_3D = def_GL_3D()
val gl_3D_COLOR = def_GL_3D_COLOR()
val gl_3D_COLOR_TEXTURE = def_GL_3D_COLOR_TEXTURE()
val gl_4D_COLOR_TEXTURE = def_GL_4D_COLOR_TEXTURE()
type feedbackmode
	= _2D
	| _3D
	| _3D_COLOR
	| _3D_COLOR_TEXTURE
	| _4D_COLOR_TEXTURE
fun feedbackmode_to_int _2D = gl_2D
|	feedbackmode_to_int _3D = gl_3D
|	feedbackmode_to_int _3D_COLOR = gl_3D_COLOR
|	feedbackmode_to_int _3D_COLOR_TEXTURE = gl_3D_COLOR_TEXTURE
|	feedbackmode_to_int _4D_COLOR_TEXTURE = gl_4D_COLOR_TEXTURE
(* FeedBackToken *)
val gl_PASS_THROUGH_TOKEN = def_GL_PASS_THROUGH_TOKEN()
val gl_POINT_TOKEN = def_GL_POINT_TOKEN()
val gl_LINE_TOKEN = def_GL_LINE_TOKEN()
val gl_POLYGON_TOKEN = def_GL_POLYGON_TOKEN()
val gl_BITMAP_TOKEN = def_GL_BITMAP_TOKEN()
val gl_DRAW_PIXEL_TOKEN = def_GL_DRAW_PIXEL_TOKEN()
val gl_COPY_PIXEL_TOKEN = def_GL_COPY_PIXEL_TOKEN()
val gl_LINE_RESET_TOKEN = def_GL_LINE_RESET_TOKEN()
type feedbacktoken
	= PASS_THROUGH_TOKEN
	| POINT_TOKEN
	| LINE_TOKEN
	| POLYGON_TOKEN
	| BITMAP_TOKEN
	| DRAW_PIXEL_TOKEN
	| COPY_PIXEL_TOKEN
	| LINE_RESET_TOKEN
fun feedbacktoken PASS_THROUGH_TOKEN = gl_PASS_THROUGH_TOKEN
|	feedbacktoken POINT_TOKEN = gl_POINT_TOKEN
|	feedbacktoken LINE_TOKEN = gl_LINE_TOKEN
|	feedbacktoken POLYGON_TOKEN = gl_POLYGON_TOKEN
|	feedbacktoken BITMAP_TOKEN = gl_BITMAP_TOKEN
|	feedbacktoken DRAW_PIXEL_TOKEN = gl_DRAW_PIXEL_TOKEN
|	feedbacktoken COPY_PIXEL_TOKEN = gl_COPY_PIXEL_TOKEN
|	feedbacktoken LINE_RESET_TOKEN = gl_LINE_RESET_TOKEN
(* FrontFaceDirection *)
val gl_CW = def_GL_CW()
val gl_CCW = def_GL_CCW()
type fdirection = CW | CCW
fun fdirection_to_int CW = gl_CW
|	fdirection_to_int CCW = gl_CCW
(* GetMapTarget *)
val gl_COEFF = def_GL_COEFF()
val gl_ORDER = def_GL_ORDER()
val gl_DOMAIN = def_GL_DOMAIN()
type getmaptarget = COEFF | ORDER | DOMAIN
fun getmaptarget_to_int COEFF = gl_COEFF
|	getmaptarget_to_int ORDER = gl_ORDER
|	getmaptarget_to_int DOMAIN = gl_DOMAIN
(* GetPointerTarget *)
(*      GL_VERTEX_ARRAY_POINTER *)
(*      GL_NORMAL_ARRAY_POINTER *)
(*      GL_COLOR_ARRAY_POINTER *)
(*      GL_INDEX_ARRAY_POINTER *)
(*      GL_TEXTURE_COORD_ARRAY_POINTER *)
(*      GL_EDGE_FLAG_ARRAY_POINTER *)
(* GetTarget *)
val gl_CURRENT_COLOR = def_GL_CURRENT_COLOR()
val gl_CURRENT_INDEX = def_GL_CURRENT_INDEX()
val gl_CURRENT_NORMAL = def_GL_CURRENT_NORMAL()
val gl_CURRENT_TEXTURE_COORDS = def_GL_CURRENT_TEXTURE_COORDS()
val gl_CURRENT_RASTER_COLOR = def_GL_CURRENT_RASTER_COLOR()
val gl_CURRENT_RASTER_INDEX = def_GL_CURRENT_RASTER_INDEX()
val gl_CURRENT_RASTER_TEXTURE_COORDS = def_GL_CURRENT_RASTER_TEXTURE_COORDS()
val gl_CURRENT_RASTER_POSITION = def_GL_CURRENT_RASTER_POSITION()
val gl_CURRENT_RASTER_POSITION_VALID = def_GL_CURRENT_RASTER_POSITION_VALID()
val gl_CURRENT_RASTER_DISTANCE = def_GL_CURRENT_RASTER_DISTANCE()
val gl_POINT_SMOOTH = def_GL_POINT_SMOOTH()
val gl_POINT_SIZE = def_GL_POINT_SIZE()
val gl_POINT_SIZE_RANGE = def_GL_POINT_SIZE_RANGE()
val gl_POINT_SIZE_GRANULARITY = def_GL_POINT_SIZE_GRANULARITY()
val gl_LINE_SMOOTH = def_GL_LINE_SMOOTH()
val gl_LINE_WIDTH = def_GL_LINE_WIDTH()
val gl_LINE_WIDTH_RANGE = def_GL_LINE_WIDTH_RANGE()
val gl_LINE_WIDTH_GRANULARITY = def_GL_LINE_WIDTH_GRANULARITY()
val gl_LINE_STIPPLE = def_GL_LINE_STIPPLE()
val gl_LINE_STIPPLE_PATTERN = def_GL_LINE_STIPPLE_PATTERN()
val gl_LINE_STIPPLE_REPEAT = def_GL_LINE_STIPPLE_REPEAT()
val gl_LIST_MODE = def_GL_LIST_MODE()
val gl_MAX_LIST_NESTING = def_GL_MAX_LIST_NESTING()
val gl_LIST_BASE = def_GL_LIST_BASE()
val gl_LIST_INDEX = def_GL_LIST_INDEX()
val gl_POLYGON_MODE = def_GL_POLYGON_MODE()
val gl_POLYGON_SMOOTH = def_GL_POLYGON_SMOOTH()
val gl_POLYGON_STIPPLE = def_GL_POLYGON_STIPPLE()
val gl_EDGE_FLAG = def_GL_EDGE_FLAG()
val gl_CULL_FACE = def_GL_CULL_FACE()
val gl_CULL_FACE_MODE = def_GL_CULL_FACE_MODE()
val gl_FRONT_FACE = def_GL_FRONT_FACE()
val gl_LIGHTING = def_GL_LIGHTING()
val gl_LIGHT_MODEL_LOCAL_VIEWER = def_GL_LIGHT_MODEL_LOCAL_VIEWER()
val gl_LIGHT_MODEL_TWO_SIDE = def_GL_LIGHT_MODEL_TWO_SIDE()
val gl_LIGHT_MODEL_AMBIENT = def_GL_LIGHT_MODEL_AMBIENT()
val gl_SHADE_MODEL = def_GL_SHADE_MODEL()
val gl_COLOR_MATERIAL_FACE = def_GL_COLOR_MATERIAL_FACE()
val gl_COLOR_MATERIAL_PARAMETER = def_GL_COLOR_MATERIAL_PARAMETER()
val gl_COLOR_MATERIAL = def_GL_COLOR_MATERIAL()
val gl_FOG = def_GL_FOG()
val gl_FOG_INDEX = def_GL_FOG_INDEX()
val gl_FOG_DENSITY = def_GL_FOG_DENSITY()
val gl_FOG_START = def_GL_FOG_START()
val gl_FOG_END = def_GL_FOG_END()
val gl_FOG_MODE = def_GL_FOG_MODE()
val gl_FOG_COLOR = def_GL_FOG_COLOR()
val gl_DEPTH_RANGE = def_GL_DEPTH_RANGE()
val gl_DEPTH_TEST = def_GL_DEPTH_TEST()
val gl_DEPTH_WRITEMASK = def_GL_DEPTH_WRITEMASK()
val gl_DEPTH_CLEAR_VALUE = def_GL_DEPTH_CLEAR_VALUE()
val gl_DEPTH_FUNC = def_GL_DEPTH_FUNC()
val gl_ACCUM_CLEAR_VALUE = def_GL_ACCUM_CLEAR_VALUE()
val gl_STENCIL_TEST = def_GL_STENCIL_TEST()
val gl_STENCIL_CLEAR_VALUE = def_GL_STENCIL_CLEAR_VALUE()
val gl_STENCIL_FUNC = def_GL_STENCIL_FUNC()
val gl_STENCIL_VALUE_MASK = def_GL_STENCIL_VALUE_MASK()
val gl_STENCIL_FAIL = def_GL_STENCIL_FAIL()
val gl_STENCIL_PASS_DEPTH_FAIL = def_GL_STENCIL_PASS_DEPTH_FAIL()
val gl_STENCIL_PASS_DEPTH_PASS = def_GL_STENCIL_PASS_DEPTH_PASS()
val gl_STENCIL_REF = def_GL_STENCIL_REF()
val gl_STENCIL_WRITEMASK = def_GL_STENCIL_WRITEMASK()
val gl_MATRIX_MODE = def_GL_MATRIX_MODE()
val gl_NORMALIZE = def_GL_NORMALIZE()
val gl_VIEWPORT = def_GL_VIEWPORT()
val gl_MODELVIEW_STACK_DEPTH = def_GL_MODELVIEW_STACK_DEPTH()
val gl_PROJECTION_STACK_DEPTH = def_GL_PROJECTION_STACK_DEPTH()
val gl_TEXTURE_STACK_DEPTH = def_GL_TEXTURE_STACK_DEPTH()
val gl_MODELVIEW_MATRIX = def_GL_MODELVIEW_MATRIX()
val gl_PROJECTION_MATRIX = def_GL_PROJECTION_MATRIX()
val gl_TEXTURE_MATRIX = def_GL_TEXTURE_MATRIX()
val gl_ATTRIB_STACK_DEPTH = def_GL_ATTRIB_STACK_DEPTH()
val gl_CLIENT_ATTRIB_STACK_DEPTH = def_GL_CLIENT_ATTRIB_STACK_DEPTH()
val gl_ALPHA_TEST = def_GL_ALPHA_TEST()
val gl_ALPHA_TEST_FUNC = def_GL_ALPHA_TEST_FUNC()
val gl_ALPHA_TEST_REF = def_GL_ALPHA_TEST_REF()
val gl_DITHER = def_GL_DITHER()
val gl_BLEND_DST = def_GL_BLEND_DST()
val gl_BLEND_SRC = def_GL_BLEND_SRC()
val gl_BLEND = def_GL_BLEND()
val gl_LOGIC_OP_MODE = def_GL_LOGIC_OP_MODE()
val gl_INDEX_LOGIC_OP = def_GL_INDEX_LOGIC_OP()
val gl_COLOR_LOGIC_OP = def_GL_COLOR_LOGIC_OP()
val gl_AUX_BUFFERS = def_GL_AUX_BUFFERS()
val gl_DRAW_BUFFER = def_GL_DRAW_BUFFER()
val gl_READ_BUFFER = def_GL_READ_BUFFER()
val gl_SCISSOR_BOX = def_GL_SCISSOR_BOX()
val gl_SCISSOR_TEST = def_GL_SCISSOR_TEST()
val gl_INDEX_CLEAR_VALUE = def_GL_INDEX_CLEAR_VALUE()
val gl_INDEX_WRITEMASK = def_GL_INDEX_WRITEMASK()
val gl_COLOR_CLEAR_VALUE = def_GL_COLOR_CLEAR_VALUE()
val gl_COLOR_WRITEMASK = def_GL_COLOR_WRITEMASK()
val gl_INDEX_MODE = def_GL_INDEX_MODE()
val gl_RGBA_MODE = def_GL_RGBA_MODE()
val gl_DOUBLEBUFFER = def_GL_DOUBLEBUFFER()
val gl_STEREO = def_GL_STEREO()
val gl_RENDER_MODE = def_GL_RENDER_MODE()
val gl_PERSPECTIVE_CORRECTION_HINT = def_GL_PERSPECTIVE_CORRECTION_HINT()
val gl_POINT_SMOOTH_HINT = def_GL_POINT_SMOOTH_HINT()
val gl_LINE_SMOOTH_HINT = def_GL_LINE_SMOOTH_HINT()
val gl_POLYGON_SMOOTH_HINT = def_GL_POLYGON_SMOOTH_HINT()
val gl_FOG_HINT = def_GL_FOG_HINT()
val gl_TEXTURE_GEN_S = def_GL_TEXTURE_GEN_S()
val gl_TEXTURE_GEN_T = def_GL_TEXTURE_GEN_T()
val gl_TEXTURE_GEN_R = def_GL_TEXTURE_GEN_R()
val gl_TEXTURE_GEN_Q = def_GL_TEXTURE_GEN_Q()
val gl_PIXEL_MAP_I_TO_I = def_GL_PIXEL_MAP_I_TO_I()
val gl_PIXEL_MAP_S_TO_S = def_GL_PIXEL_MAP_S_TO_S()
val gl_PIXEL_MAP_I_TO_R = def_GL_PIXEL_MAP_I_TO_R()
val gl_PIXEL_MAP_I_TO_G = def_GL_PIXEL_MAP_I_TO_G()
val gl_PIXEL_MAP_I_TO_B = def_GL_PIXEL_MAP_I_TO_B()
val gl_PIXEL_MAP_I_TO_A = def_GL_PIXEL_MAP_I_TO_A()
val gl_PIXEL_MAP_R_TO_R = def_GL_PIXEL_MAP_R_TO_R()
val gl_PIXEL_MAP_G_TO_G = def_GL_PIXEL_MAP_G_TO_G()
val gl_PIXEL_MAP_B_TO_B = def_GL_PIXEL_MAP_B_TO_B()
val gl_PIXEL_MAP_A_TO_A = def_GL_PIXEL_MAP_A_TO_A()
val gl_PIXEL_MAP_I_TO_I_SIZE = def_GL_PIXEL_MAP_I_TO_I_SIZE()
val gl_PIXEL_MAP_S_TO_S_SIZE = def_GL_PIXEL_MAP_S_TO_S_SIZE()
val gl_PIXEL_MAP_I_TO_R_SIZE = def_GL_PIXEL_MAP_I_TO_R_SIZE()
val gl_PIXEL_MAP_I_TO_G_SIZE = def_GL_PIXEL_MAP_I_TO_G_SIZE()
val gl_PIXEL_MAP_I_TO_B_SIZE = def_GL_PIXEL_MAP_I_TO_B_SIZE()
val gl_PIXEL_MAP_I_TO_A_SIZE = def_GL_PIXEL_MAP_I_TO_A_SIZE()
val gl_PIXEL_MAP_R_TO_R_SIZE = def_GL_PIXEL_MAP_R_TO_R_SIZE()
val gl_PIXEL_MAP_G_TO_G_SIZE = def_GL_PIXEL_MAP_G_TO_G_SIZE()
val gl_PIXEL_MAP_B_TO_B_SIZE = def_GL_PIXEL_MAP_B_TO_B_SIZE()
val gl_PIXEL_MAP_A_TO_A_SIZE = def_GL_PIXEL_MAP_A_TO_A_SIZE()
val gl_UNPACK_SWAP_BYTES = def_GL_UNPACK_SWAP_BYTES()
val gl_UNPACK_LSB_FIRST = def_GL_UNPACK_LSB_FIRST()
val gl_UNPACK_ROW_LENGTH = def_GL_UNPACK_ROW_LENGTH()
val gl_UNPACK_SKIP_ROWS = def_GL_UNPACK_SKIP_ROWS()
val gl_UNPACK_SKIP_PIXELS = def_GL_UNPACK_SKIP_PIXELS()
val gl_UNPACK_ALIGNMENT = def_GL_UNPACK_ALIGNMENT()
val gl_PACK_SWAP_BYTES = def_GL_PACK_SWAP_BYTES()
val gl_PACK_LSB_FIRST = def_GL_PACK_LSB_FIRST()
val gl_PACK_ROW_LENGTH = def_GL_PACK_ROW_LENGTH()
val gl_PACK_SKIP_ROWS = def_GL_PACK_SKIP_ROWS()
val gl_PACK_SKIP_PIXELS = def_GL_PACK_SKIP_PIXELS()
val gl_PACK_ALIGNMENT = def_GL_PACK_ALIGNMENT()
val gl_MAP_COLOR = def_GL_MAP_COLOR()
val gl_MAP_STENCIL = def_GL_MAP_STENCIL()
val gl_INDEX_SHIFT = def_GL_INDEX_SHIFT()
val gl_INDEX_OFFSET = def_GL_INDEX_OFFSET()
val gl_RED_SCALE = def_GL_RED_SCALE()
val gl_RED_BIAS = def_GL_RED_BIAS()
val gl_ZOOM_X = def_GL_ZOOM_X()
val gl_ZOOM_Y = def_GL_ZOOM_Y()
val gl_GREEN_SCALE = def_GL_GREEN_SCALE()
val gl_GREEN_BIAS = def_GL_GREEN_BIAS()
val gl_BLUE_SCALE = def_GL_BLUE_SCALE()
val gl_BLUE_BIAS = def_GL_BLUE_BIAS()
val gl_ALPHA_SCALE = def_GL_ALPHA_SCALE()
val gl_ALPHA_BIAS = def_GL_ALPHA_BIAS()
val gl_DEPTH_SCALE = def_GL_DEPTH_SCALE()
val gl_DEPTH_BIAS = def_GL_DEPTH_BIAS()
val gl_MAX_EVAL_ORDER = def_GL_MAX_EVAL_ORDER()
val gl_MAX_LIGHTS = def_GL_MAX_LIGHTS()
val gl_MAX_CLIP_PLANES = def_GL_MAX_CLIP_PLANES()
val gl_MAX_TEXTURE_SIZE = def_GL_MAX_TEXTURE_SIZE()
val gl_MAX_PIXEL_MAP_TABLE = def_GL_MAX_PIXEL_MAP_TABLE()
val gl_MAX_ATTRIB_STACK_DEPTH = def_GL_MAX_ATTRIB_STACK_DEPTH()
val gl_MAX_MODELVIEW_STACK_DEPTH = def_GL_MAX_MODELVIEW_STACK_DEPTH()
val gl_MAX_NAME_STACK_DEPTH = def_GL_MAX_NAME_STACK_DEPTH()
val gl_MAX_PROJECTION_STACK_DEPTH = def_GL_MAX_PROJECTION_STACK_DEPTH()
val gl_MAX_TEXTURE_STACK_DEPTH = def_GL_MAX_TEXTURE_STACK_DEPTH()
val gl_MAX_VIEWPORT_DIMS = def_GL_MAX_VIEWPORT_DIMS()
val gl_MAX_CLIENT_ATTRIB_STACK_DEPTH = def_GL_MAX_CLIENT_ATTRIB_STACK_DEPTH()
val gl_SUBPIXEL_BITS = def_GL_SUBPIXEL_BITS()
val gl_INDEX_BITS = def_GL_INDEX_BITS()
val gl_RED_BITS = def_GL_RED_BITS()
val gl_GREEN_BITS = def_GL_GREEN_BITS()
val gl_BLUE_BITS = def_GL_BLUE_BITS()
val gl_ALPHA_BITS = def_GL_ALPHA_BITS()
val gl_DEPTH_BITS = def_GL_DEPTH_BITS()
val gl_STENCIL_BITS = def_GL_STENCIL_BITS()
val gl_ACCUM_RED_BITS = def_GL_ACCUM_RED_BITS()
val gl_ACCUM_GREEN_BITS = def_GL_ACCUM_GREEN_BITS()
val gl_ACCUM_BLUE_BITS = def_GL_ACCUM_BLUE_BITS()
val gl_ACCUM_ALPHA_BITS = def_GL_ACCUM_ALPHA_BITS()
val gl_NAME_STACK_DEPTH = def_GL_NAME_STACK_DEPTH()
val gl_AUTO_NORMAL = def_GL_AUTO_NORMAL()
val gl_MAP1_COLOR_4 = def_GL_MAP1_COLOR_4()
val gl_MAP1_INDEX = def_GL_MAP1_INDEX()
val gl_MAP1_NORMAL = def_GL_MAP1_NORMAL()
val gl_MAP1_TEXTURE_COORD_1 = def_GL_MAP1_TEXTURE_COORD_1()
val gl_MAP1_TEXTURE_COORD_2 = def_GL_MAP1_TEXTURE_COORD_2()
val gl_MAP1_TEXTURE_COORD_3 = def_GL_MAP1_TEXTURE_COORD_3()
val gl_MAP1_TEXTURE_COORD_4 = def_GL_MAP1_TEXTURE_COORD_4()
val gl_MAP1_VERTEX_3 = def_GL_MAP1_VERTEX_3()
val gl_MAP1_VERTEX_4 = def_GL_MAP1_VERTEX_4()
val gl_MAP2_COLOR_4 = def_GL_MAP2_COLOR_4()
val gl_MAP2_INDEX = def_GL_MAP2_INDEX()
val gl_MAP2_NORMAL = def_GL_MAP2_NORMAL()
val gl_MAP2_TEXTURE_COORD_1 = def_GL_MAP2_TEXTURE_COORD_1()
val gl_MAP2_TEXTURE_COORD_2 = def_GL_MAP2_TEXTURE_COORD_2()
val gl_MAP2_TEXTURE_COORD_3 = def_GL_MAP2_TEXTURE_COORD_3()
val gl_MAP2_TEXTURE_COORD_4 = def_GL_MAP2_TEXTURE_COORD_4()
val gl_MAP2_VERTEX_3 = def_GL_MAP2_VERTEX_3()
val gl_MAP2_VERTEX_4 = def_GL_MAP2_VERTEX_4()
val gl_MAP1_GRID_DOMAIN = def_GL_MAP1_GRID_DOMAIN()
val gl_MAP1_GRID_SEGMENTS = def_GL_MAP1_GRID_SEGMENTS()
val gl_MAP2_GRID_DOMAIN = def_GL_MAP2_GRID_DOMAIN()
val gl_MAP2_GRID_SEGMENTS = def_GL_MAP2_GRID_SEGMENTS()
val gl_TEXTURE_1D = def_GL_TEXTURE_1D()
val gl_TEXTURE_2D = def_GL_TEXTURE_2D()
val gl_FEEDBACK_BUFFER_POINTER = def_GL_FEEDBACK_BUFFER_POINTER()
val gl_FEEDBACK_BUFFER_SIZE = def_GL_FEEDBACK_BUFFER_SIZE()
val gl_FEEDBACK_BUFFER_TYPE = def_GL_FEEDBACK_BUFFER_TYPE()
val gl_SELECTION_BUFFER_POINTER = def_GL_SELECTION_BUFFER_POINTER()
val gl_SELECTION_BUFFER_SIZE = def_GL_SELECTION_BUFFER_SIZE()
(*      GL_TEXTURE_BINDING_1D *)
(*      GL_TEXTURE_BINDING_2D *)
(*      GL_VERTEX_ARRAY *)
(*      GL_NORMAL_ARRAY *)
(*      GL_COLOR_ARRAY *)
(*      GL_INDEX_ARRAY *)
(*      GL_TEXTURE_COORD_ARRAY *)
(*      GL_EDGE_FLAG_ARRAY *)
(*      GL_VERTEX_ARRAY_SIZE *)
(*      GL_VERTEX_ARRAY_TYPE *)
(*      GL_VERTEX_ARRAY_STRIDE *)
(*      GL_NORMAL_ARRAY_TYPE *)
(*      GL_NORMAL_ARRAY_STRIDE *)
(*      GL_COLOR_ARRAY_SIZE *)
(*      GL_COLOR_ARRAY_TYPE *)
(*      GL_COLOR_ARRAY_STRIDE *)
(*      GL_INDEX_ARRAY_TYPE *)
(*      GL_INDEX_ARRAY_STRIDE *)
(*      GL_TEXTURE_COORD_ARRAY_SIZE *)
(*      GL_TEXTURE_COORD_ARRAY_TYPE *)
(*      GL_TEXTURE_COORD_ARRAY_STRIDE *)
(*      GL_EDGE_FLAG_ARRAY_STRIDE *)
(*      GL_POLYGON_OFFSET_FACTOR *)
(*      GL_POLYGON_OFFSET_UNITS *)
(* texture_object *)
val gl_TEXTURE_PRIORITY = def_GL_TEXTURE_PRIORITY()
val gl_TEXTURE_RESIDENT = def_GL_TEXTURE_RESIDENT()
val gl_TEXTURE_BINDING_1D = def_GL_TEXTURE_BINDING_1D()
val gl_TEXTURE_BINDING_2D = def_GL_TEXTURE_BINDING_2D()
(* GetTextureParameter *)
(*      GL_TEXTURE_MAG_FILTER *)
(*      GL_TEXTURE_MIN_FILTER *)
(*      GL_TEXTURE_WRAP_S *)
(*      GL_TEXTURE_WRAP_T *)
val gl_TEXTURE_WIDTH = def_GL_TEXTURE_WIDTH()
val gl_TEXTURE_HEIGHT = def_GL_TEXTURE_HEIGHT()
val gl_TEXTURE_INTERNAL_FORMAT = def_GL_TEXTURE_INTERNAL_FORMAT()
val gl_TEXTURE_BORDER_COLOR = def_GL_TEXTURE_BORDER_COLOR()
val gl_TEXTURE_BORDER = def_GL_TEXTURE_BORDER()
(*      GL_TEXTURE_RED_SIZE *)
(*      GL_TEXTURE_GREEN_SIZE *)
(*      GL_TEXTURE_BLUE_SIZE *)
(*      GL_TEXTURE_ALPHA_SIZE *)
(*      GL_TEXTURE_LUMINANCE_SIZE *)
(*      GL_TEXTURE_INTENSITY_SIZE *)
(*      GL_TEXTURE_PRIORITY *)
(*      GL_TEXTURE_RESIDENT *)
(* HintMode *)
val gl_DONT_CARE = def_GL_DONT_CARE()
val gl_FASTEST = def_GL_FASTEST()
val gl_NICEST = def_GL_NICEST()
type hintmode = DONT_CARE | FASTEST | NICEST
fun hintmode_to_int DONT_CARE = gl_DONT_CARE
|	hintmode_to_int FASTEST = gl_FASTEST
|	hintmode_to_int NICEST = gl_NICEST
(* HintTarget *)
(*      GL_PERSPECTIVE_CORRECTION_HINT *)
(*      GL_POINT_SMOOTH_HINT *)
(*      GL_LINE_SMOOTH_HINT *)
(*      GL_POLYGON_SMOOTH_HINT *)
(*      GL_FOG_HINT *)
(*      GL_PHONG_HINT *)
type hinttarget
	= PERSPECTIVE_CORRECTION_HINT
	| POINT_SMOOTH_HINT
	| LINE_SMOOTH_HINT
	| POLYGON_SMOOTH_HINT
	| FOG_HINT
fun hinttarget_to_int PERSPECTIVE_CORRECTION_HINT = gl_PERSPECTIVE_CORRECTION_HINT
|	hinttarget_to_int POINT_SMOOTH_HINT = gl_POINT_SMOOTH_HINT
|	hinttarget_to_int LINE_SMOOTH_HINT = gl_LINE_SMOOTH_HINT
|	hinttarget_to_int POLYGON_SMOOTH_HINT = gl_POLYGON_SMOOTH_HINT
|	hinttarget_to_int FOG_HINT = gl_FOG_HINT
(* LightModelParameter *)
(*      GL_LIGHT_MODEL_AMBIENT *)
(*      GL_LIGHT_MODEL_LOCAL_VIEWER *)
(*      GL_LIGHT_MODEL_TWO_SIDE *)
type lmparamfv = LIGHT_MODEL_AMBIENT
type lmparami = LIGHT_MODEL_LOCAL_VIEWER | LIGHT_MODEL_TWO_SIDE
fun lmparamfv_to_int LIGHT_MODEL_AMBIENT = gl_LIGHT_MODEL_AMBIENT
fun lmparami_to_int LIGHT_MODEL_LOCAL_VIEWER = gl_LIGHT_MODEL_LOCAL_VIEWER
|	lmparami_to_int LIGHT_MODEL_TWO_SIDE = gl_LIGHT_MODEL_TWO_SIDE
(* LightName *)
val gl_LIGHT0 = def_GL_LIGHT0()
val gl_LIGHT1 = def_GL_LIGHT1()
val gl_LIGHT2 = def_GL_LIGHT2()
val gl_LIGHT3 = def_GL_LIGHT3()
val gl_LIGHT4 = def_GL_LIGHT4()
val gl_LIGHT5 = def_GL_LIGHT5()
val gl_LIGHT6 = def_GL_LIGHT6()
val gl_LIGHT7 = def_GL_LIGHT7()
type lightname
	= LIGHT0
	| LIGHT1
	| LIGHT2
	| LIGHT3
	| LIGHT4
	| LIGHT5
	| LIGHT6
	| LIGHT7
fun lightname_to_int LIGHT0 = gl_LIGHT0
|	lightname_to_int LIGHT1 = gl_LIGHT1
|	lightname_to_int LIGHT2 = gl_LIGHT2
|	lightname_to_int LIGHT3 = gl_LIGHT3
|	lightname_to_int LIGHT4 = gl_LIGHT4
|	lightname_to_int LIGHT5 = gl_LIGHT5
|	lightname_to_int LIGHT6 = gl_LIGHT6
|	lightname_to_int LIGHT7 = gl_LIGHT7
(* LightParameter *)
val gl_AMBIENT = def_GL_AMBIENT()
val gl_DIFFUSE = def_GL_DIFFUSE()
val gl_SPECULAR = def_GL_SPECULAR()
val gl_POSITION = def_GL_POSITION()
val gl_SPOT_DIRECTION = def_GL_SPOT_DIRECTION()
val gl_SPOT_EXPONENT = def_GL_SPOT_EXPONENT()
val gl_SPOT_CUTOFF = def_GL_SPOT_CUTOFF()
val gl_CONSTANT_ATTENUATION = def_GL_CONSTANT_ATTENUATION()
val gl_LINEAR_ATTENUATION = def_GL_LINEAR_ATTENUATION()
val gl_QUADRATIC_ATTENUATION = def_GL_QUADRATIC_ATTENUATION()
type lightfvparam
	= L_AMBIENT
	| L_DIFFUSE
	| L_SPECULAR
	| POSITION
	| SPOT_DIRECTION
type lightfparam
	= SPOT_EXPONENT
	| SPOT_CUTOFF
	| CONSTANT_ATTENUATION
	| LINEAR_ATTENUATION
	| QUADRATIC_ATTENUATION
fun lightfvparam_to_int L_AMBIENT = gl_AMBIENT
|	lightfvparam_to_int L_DIFFUSE = gl_DIFFUSE
|	lightfvparam_to_int L_SPECULAR = gl_SPECULAR
|	lightfvparam_to_int POSITION = gl_POSITION
|	lightfvparam_to_int SPOT_DIRECTION = gl_SPOT_DIRECTION
fun lightfparam_to_int SPOT_EXPONENT = gl_SPOT_EXPONENT
|	lightfparam_to_int SPOT_CUTOFF = gl_SPOT_CUTOFF
|	lightfparam_to_int CONSTANT_ATTENUATION = gl_CONSTANT_ATTENUATION
|	lightfparam_to_int LINEAR_ATTENUATION = gl_LINEAR_ATTENUATION
|	lightfparam_to_int QUADRATIC_ATTENUATION = gl_QUADRATIC_ATTENUATION
(* InterleavedArrays *)
(*      GL_V2F *)
(*      GL_V3F *)
(*      GL_C4UB_V2F *)
(*      GL_C4UB_V3F *)
(*      GL_C3F_V3F *)
(*      GL_N3F_V3F *)
(*      GL_C4F_N3F_V3F *)
(*      GL_T2F_V3F *)
(*      GL_T4F_V4F *)
(*      GL_T2F_C4UB_V3F *)
(*      GL_T2F_C3F_V3F *)
(*      GL_T2F_N3F_V3F *)
(*      GL_T2F_C4F_N3F_V3F *)
(*      GL_T4F_C4F_N3F_V4F *)
(* ListMode *)
val gl_COMPILE = def_GL_COMPILE()
val gl_COMPILE_AND_EXECUTE = def_GL_COMPILE_AND_EXECUTE()
type listmode = COMPILE | COMPILE_AND_EXECUTE
fun listmode_to_int COMPILE = gl_COMPILE
|	listmode_to_int COMPILE_AND_EXECUTE = gl_COMPILE_AND_EXECUTE
(* LogicOp *)
val gl_CLEAR = def_GL_CLEAR()
val gl_AND = def_GL_AND()
val gl_AND_REVERSE = def_GL_AND_REVERSE()
val gl_COPY = def_GL_COPY()
val gl_AND_INVERTED = def_GL_AND_INVERTED()
val gl_NOOP = def_GL_NOOP()
val gl_XOR = def_GL_XOR()
val gl_OR = def_GL_OR()
val gl_NOR = def_GL_NOR()
val gl_EQUIV = def_GL_EQUIV()
val gl_INVERT = def_GL_INVERT()
val gl_OR_REVERSE = def_GL_OR_REVERSE()
val gl_COPY_INVERTED = def_GL_COPY_INVERTED()
val gl_OR_INVERTED = def_GL_OR_INVERTED()
val gl_NAND = def_GL_NAND()
val gl_SET = def_GL_SET()
type logicop
	= CLEAR
	| AND
	| AND_REVERSE
	| COPY
	| AND_INVERTED
	| NOOP
	| XOR
	| OR
	| NOR
	| EQUIV
	| INVERT
	| OR_REVERSE
	| COPY_INVERTED
	| OR_INVERTED
	| NAND
	| SET
fun logicop_to_int CLEAR = gl_CLEAR
|	logicop_to_int AND = gl_AND
|	logicop_to_int AND_REVERSE = gl_AND_REVERSE
|	logicop_to_int COPY = gl_COPY
|	logicop_to_int AND_INVERTED = gl_AND_INVERTED 
|	logicop_to_int NOOP = gl_NOOP
|	logicop_to_int XOR = gl_XOR
|	logicop_to_int OR = gl_OR
|	logicop_to_int NOR = gl_NOR
|	logicop_to_int EQUIV = gl_EQUIV
|	logicop_to_int INVERT = gl_INVERT
|	logicop_to_int OR_REVERSE = gl_OR_REVERSE
|	logicop_to_int COPY_INVERTED = gl_COPY_INVERTED
|	logicop_to_int OR_INVERTED = gl_OR_INVERTED
|	logicop_to_int NAND = gl_NAND
|	logicop_to_int SET = gl_SET
(* MapTarget *)
(*      GL_MAP1_COLOR_4 *)
(*      GL_MAP1_INDEX *)
(*      GL_MAP1_NORMAL *)
(*      GL_MAP1_TEXTURE_COORD_1 *)
(*      GL_MAP1_TEXTURE_COORD_2 *)
(*      GL_MAP1_TEXTURE_COORD_3 *)
(*      GL_MAP1_TEXTURE_COORD_4 *)
(*      GL_MAP1_VERTEX_3 *)
(*      GL_MAP1_VERTEX_4 *)
type map1target
	= MAP1_COLOR_4
	| MAP1_INDEX
	| MAP1_NORMAL
	| MAP1_TEXTURE_COORD_1
	| MAP1_TEXTURE_COORD_2
	| MAP1_TEXTURE_COORD_3
	| MAP1_TEXTURE_COORD_4
	| MAP1_VERTEX_3
	| MAP1_VERTEX_4
fun map1target_to_int MAP1_COLOR_4 = gl_MAP1_COLOR_4
|	map1target_to_int MAP1_INDEX = gl_MAP1_INDEX
|	map1target_to_int MAP1_NORMAL = gl_MAP1_NORMAL
|	map1target_to_int MAP1_TEXTURE_COORD_1 = gl_MAP1_TEXTURE_COORD_1
|	map1target_to_int MAP1_TEXTURE_COORD_2 = gl_MAP1_TEXTURE_COORD_2
|	map1target_to_int MAP1_TEXTURE_COORD_3 = gl_MAP1_TEXTURE_COORD_3
|	map1target_to_int MAP1_TEXTURE_COORD_4 = gl_MAP1_TEXTURE_COORD_4
|	map1target_to_int MAP1_VERTEX_3 = gl_MAP1_VERTEX_3
|	map1target_to_int MAP1_VERTEX_4 = gl_MAP1_VERTEX_4
(*      GL_MAP2_COLOR_4 *)
(*      GL_MAP2_INDEX *)
(*      GL_MAP2_NORMAL *)
(*      GL_MAP2_TEXTURE_COORD_1 *)
(*      GL_MAP2_TEXTURE_COORD_2 *)
(*      GL_MAP2_TEXTURE_COORD_3 *)
(*      GL_MAP2_TEXTURE_COORD_4 *)
(*      GL_MAP2_VERTEX_3 *)
(*      GL_MAP2_VERTEX_4 *)
type map2target
	= MAP2_COLOR_4
	| MAP2_INDEX
	| MAP2_NORMAL
	| MAP2_TEXTURE_COORD_1
	| MAP2_TEXTURE_COORD_2
	| MAP2_TEXTURE_COORD_3
	| MAP2_TEXTURE_COORD_4
	| MAP2_VERTEX_3
	| MAP2_VERTEX_4
fun map2target_to_int MAP2_COLOR_4 = gl_MAP1_COLOR_4
|	map2target_to_int MAP2_INDEX = gl_MAP1_INDEX
|	map2target_to_int MAP2_NORMAL = gl_MAP1_NORMAL
|	map2target_to_int MAP2_TEXTURE_COORD_1 = gl_MAP1_TEXTURE_COORD_1
|	map2target_to_int MAP2_TEXTURE_COORD_2 = gl_MAP1_TEXTURE_COORD_2
|	map2target_to_int MAP2_TEXTURE_COORD_3 = gl_MAP1_TEXTURE_COORD_3
|	map2target_to_int MAP2_TEXTURE_COORD_4 = gl_MAP1_TEXTURE_COORD_4
|	map2target_to_int MAP2_VERTEX_3 = gl_MAP1_VERTEX_3
|	map2target_to_int MAP2_VERTEX_4 = gl_MAP1_VERTEX_4
(* MaterialFace *)
(*      GL_FRONT *)
(*      GL_BACK *)
(*      GL_FRONT_AND_BACK *)
type face = F_FRONT | F_BACK | F_FRONT_AND_BACK
fun face_to_int F_FRONT = gl_FRONT
|	face_to_int F_BACK = gl_BACK
|	face_to_int F_FRONT_AND_BACK = gl_FRONT_AND_BACK
(* MaterialParameter *)
val gl_EMISSION = def_GL_EMISSION()
val gl_SHININESS = def_GL_SHININESS()
val gl_AMBIENT_AND_DIFFUSE = def_GL_AMBIENT_AND_DIFFUSE()
val gl_COLOR_INDEXES = def_GL_COLOR_INDEXES()
(*      GL_AMBIENT *)
(*      GL_DIFFUSE *)
(*      GL_SPECULAR *)
type materialfvparam
	= AMBIENT_AND_DIFFUSE
	| M_AMBIENT
	| M_DIFFUSE
	| M_SPECULAR
	| EMISSION
	| COLOR_INDEXES
type materialfparam
	= SHININESS
fun materialfvparam_to_int AMBIENT_AND_DIFFUSE = gl_AMBIENT_AND_DIFFUSE
|	materialfvparam_to_int M_AMBIENT = gl_AMBIENT
|	materialfvparam_to_int M_DIFFUSE = gl_DIFFUSE
|	materialfvparam_to_int M_SPECULAR = gl_SPECULAR
|	materialfvparam_to_int EMISSION = gl_EMISSION
|	materialfvparam_to_int COLOR_INDEXES = gl_COLOR_INDEXES
fun materialfparam_to_int SHININESS = gl_SHININESS
(* MatrixMode *)
val gl_MODELVIEW = def_GL_MODELVIEW()
val gl_PROJECTION = def_GL_PROJECTION()
val gl_TEXTURE = def_GL_TEXTURE()
type matrixmode = MODELVIEW | PROJECTION | TEXTURE
fun matrixmode_to_int MODELVIEW = gl_MODELVIEW
|	matrixmode_to_int PROJECTION = gl_PROJECTION
|	matrixmode_to_int TEXTURE = gl_TEXTURE
(* PixelCopyType *)
val gl_COLOR = def_GL_COLOR()
val gl_DEPTH = def_GL_DEPTH()
val gl_STENCIL = def_GL_STENCIL()
type pixelcopytype = COLOR | DEPTH | STENCIL
fun pixelcopytype_to_int COLOR = gl_COLOR
|	pixelcopytype_to_int DEPTH = gl_DEPTH
|	pixelcopytype_to_int STENCIL = gl_STENCIL
(* PixelFormat *)
val gl_COLOR_INDEX = def_GL_COLOR_INDEX()
val gl_STENCIL_INDEX = def_GL_STENCIL_INDEX()
val gl_DEPTH_COMPONENT = def_GL_DEPTH_COMPONENT()
val gl_RED = def_GL_RED()
val gl_GREEN = def_GL_GREEN()
val gl_BLUE = def_GL_BLUE()
val gl_ALPHA = def_GL_ALPHA()
val gl_RGB = def_GL_RGB()
val gl_RGBA = def_GL_RGBA()
val gl_LUMINANCE = def_GL_LUMINANCE()
val gl_LUMINANCE_ALPHA = def_GL_LUMINANCE_ALPHA()
type pixelformat
	= COLOR_INDEX
	| STENCIL_INDEX
	| DEPTH_COMPONENT
	| RED
	| GREEN
	| BLUE
	| ALPHA
	| RGB
	| RGBA
	| LUMINANCE
	| LUMINANCE_ALPHA
fun pixelformat_to_int COLOR_INDEX = gl_COLOR_INDEX
|	pixelformat_to_int STENCIL_INDEX = gl_STENCIL_INDEX
|	pixelformat_to_int DEPTH_COMPONENT = gl_DEPTH_COMPONENT
|	pixelformat_to_int RED = gl_RED
|	pixelformat_to_int GREEN = gl_GREEN
|	pixelformat_to_int BLUE = gl_BLUE
|	pixelformat_to_int ALPHA = gl_ALPHA
|	pixelformat_to_int RGB = gl_RGB
|	pixelformat_to_int RGBA = gl_RGBA
|	pixelformat_to_int LUMINANCE = gl_LUMINANCE
|	pixelformat_to_int LUMINANCE_ALPHA = gl_LUMINANCE_ALPHA
(* PixelMap *)
(*      GL_PIXEL_MAP_I_TO_I *)
(*      GL_PIXEL_MAP_S_TO_S *)
(*      GL_PIXEL_MAP_I_TO_R *)
(*      GL_PIXEL_MAP_I_TO_G *)
(*      GL_PIXEL_MAP_I_TO_B *)
(*      GL_PIXEL_MAP_I_TO_A *)
(*      GL_PIXEL_MAP_R_TO_R *)
(*      GL_PIXEL_MAP_G_TO_G *)
(*      GL_PIXEL_MAP_B_TO_B *)
(*      GL_PIXEL_MAP_A_TO_A *)
type pixelmap
	= PIXEL_MAP_I_TO_I
	| PIXEL_MAP_S_TO_S
	| PIXEL_MAP_I_TO_R
	| PIXEL_MAP_I_TO_G
	| PIXEL_MAP_I_TO_B
	| PIXEL_MAP_I_TO_A
	| PIXEL_MAP_R_TO_R
	| PIXEL_MAP_G_TO_G
	| PIXEL_MAP_B_TO_B
	| PIXEL_MAP_A_TO_A
fun pixelmap_to_int PIXEL_MAP_I_TO_I = gl_PIXEL_MAP_I_TO_I
|	pixelmap_to_int PIXEL_MAP_S_TO_S = gl_PIXEL_MAP_S_TO_S
|	pixelmap_to_int PIXEL_MAP_I_TO_R = gl_PIXEL_MAP_I_TO_R
|	pixelmap_to_int PIXEL_MAP_I_TO_G = gl_PIXEL_MAP_I_TO_G
|	pixelmap_to_int PIXEL_MAP_I_TO_B = gl_PIXEL_MAP_I_TO_B
|	pixelmap_to_int PIXEL_MAP_I_TO_A = gl_PIXEL_MAP_I_TO_A
|	pixelmap_to_int PIXEL_MAP_R_TO_R = gl_PIXEL_MAP_R_TO_R
|	pixelmap_to_int PIXEL_MAP_G_TO_G = gl_PIXEL_MAP_G_TO_G
|	pixelmap_to_int PIXEL_MAP_B_TO_B = gl_PIXEL_MAP_B_TO_B
|	pixelmap_to_int PIXEL_MAP_A_TO_A = gl_PIXEL_MAP_B_TO_B
(* PixelStore *)
(*      GL_UNPACK_SWAP_BYTES *)
(*      GL_UNPACK_LSB_FIRST *)
(*      GL_UNPACK_ROW_LENGTH *)
(*      GL_UNPACK_SKIP_ROWS *)
(*      GL_UNPACK_SKIP_PIXELS *)
(*      GL_UNPACK_ALIGNMENT *)
(*      GL_PACK_SWAP_BYTES *)
(*      GL_PACK_LSB_FIRST *)
(*      GL_PACK_ROW_LENGTH *)
(*      GL_PACK_SKIP_ROWS *)
(*      GL_PACK_SKIP_PIXELS *)
(*      GL_PACK_ALIGNMENT *)
type pixstrb
	= UNPACK_SWAP_BYTES
	| UNPACK_LSB_FIRST
fun pixstrb_to_int UNPACK_SWAP_BYTES = gl_UNPACK_SWAP_BYTES
|	pixstrb_to_int UNPACK_LSB_FIRST = gl_UNPACK_LSB_FIRST
type pixstri
	= UNPACK_ROW_LENGTH
	| UNPACK_SKIP_ROWS
	| UNPACK_SKIP_PIXELS
	| UNPACK_ALIGNMENT
	| PACK_SWAP_BYTES
	| PACK_LSB_FIRST
	| PACK_ROW_LENGTH
	| PACK_SKIP_ROWS
	| PACK_SKIP_PIXELS
	| PACK_ALIGNMENT
fun pixstri_to_int UNPACK_ROW_LENGTH = gl_UNPACK_ROW_LENGTH
|	pixstri_to_int UNPACK_SKIP_ROWS = gl_UNPACK_SKIP_ROWS
|	pixstri_to_int UNPACK_SKIP_PIXELS = gl_UNPACK_SKIP_PIXELS
|	pixstri_to_int UNPACK_ALIGNMENT = gl_UNPACK_ALIGNMENT
|	pixstri_to_int PACK_SWAP_BYTES = gl_PACK_SWAP_BYTES
|	pixstri_to_int PACK_LSB_FIRST =  gl_PACK_LSB_FIRST
|	pixstri_to_int PACK_ROW_LENGTH = gl_PACK_ROW_LENGTH
|	pixstri_to_int PACK_SKIP_ROWS =  gl_PACK_SKIP_ROWS
|	pixstri_to_int PACK_SKIP_PIXELS = gl_PACK_SKIP_PIXELS
|	pixstri_to_int PACK_ALIGNMENT =  gl_PACK_ALIGNMENT
(* PixelTransfer *)
(*      GL_MAP_COLOR *)
(*      GL_MAP_STENCIL *)
(*      GL_INDEX_SHIFT *)
(*      GL_INDEX_OFFSET *)
(*      GL_RED_SCALE *)
(*      GL_RED_BIAS *)
(*      GL_GREEN_SCALE *)
(*      GL_GREEN_BIAS *)
(*      GL_BLUE_SCALE *)
(*      GL_BLUE_BIAS *)
(*      GL_ALPHA_SCALE *)
(*      GL_ALPHA_BIAS *)
(*      GL_DEPTH_SCALE *)
(*      GL_DEPTH_BIAS *)
type pixtrsb
	= MAP_COLOR
	| MAP_STENCIL
fun pixtrsb_to_int MAP_COLOR = gl_MAP_COLOR
|	pixtrsb_to_int MAP_STENCIL = gl_MAP_STENCIL
type pixtrsi
	= INDEX_SHIFT
	| INDEX_OFFSET
fun pixtrsi_to_int INDEX_SHIFT = gl_INDEX_SHIFT
|	pixtrsi_to_int INDEX_OFFSET = gl_INDEX_OFFSET
type pixtrsf
	= RED_SCALE
	| RED_BIAS
	| GREEN_SCALE
	| GREEN_BIAS
	| BLUE_SCALE
	| BLUE_BIAS
	| ALPHA_SCALE
	| ALPHA_BIAS
	| DEPTH_SCALE
	| DEPTH_BIAS
fun pixtrsf_to_int RED_SCALE = gl_RED_SCALE
|	pixtrsf_to_int RED_BIAS = gl_RED_BIAS
|	pixtrsf_to_int GREEN_SCALE = gl_GREEN_SCALE
|	pixtrsf_to_int GREEN_BIAS = gl_GREEN_BIAS
|	pixtrsf_to_int BLUE_SCALE = gl_BLUE_SCALE
|	pixtrsf_to_int BLUE_BIAS = gl_BLUE_BIAS
|	pixtrsf_to_int ALPHA_SCALE = gl_ALPHA_SCALE
|	pixtrsf_to_int ALPHA_BIAS = gl_ALPHA_BIAS
|	pixtrsf_to_int DEPTH_SCALE = gl_DEPTH_SCALE
|	pixtrsf_to_int DEPTH_BIAS = gl_DEPTH_BIAS
(* PixelType *)
val gl_BITMAP = def_GL_BITMAP()
(*      GL_BYTE *)
(*      GL_UNSIGNED_BYTE *)
(*      GL_SHORT *)
(*      GL_UNSIGNED_SHORT *)
(*      GL_INT *)
(*      GL_UNSIGNED_INT *)
(*      GL_FLOAT *)
type pixeltype = BITMAP | PT of datatype
fun pixeltype_to_int BITMAP = gl_BITMAP
|	pixeltype_to_int (PT t) = datatype_to_int t
(* PolygonMode *)
val gl_POINT = def_GL_POINT()
val gl_LINE = def_GL_LINE()
val gl_FILL = def_GL_FILL()
type mpmode = POINT | LINE | FILL
fun mpmode_to_int POINT = gl_POINT
|	mpmode_to_int LINE = gl_LINE
|	mpmode_to_int FILL = gl_FILL
(* RenderingMode *)
val gl_RENDER = def_GL_RENDER()
val gl_FEEDBACK = def_GL_FEEDBACK()
val gl_SELECT = def_GL_SELECT()
type rendermode = RENDER | FEEDBACK | SELECT
fun rendermode_to_int RENDER = gl_RENDER
|	rendermode_to_int FEEDBACK = gl_FEEDBACK
|	rendermode_to_int SELECT = gl_SELECT
(* ShadingModel *)
val gl_FLAT = def_GL_FLAT()
val gl_SMOOTH = def_GL_SMOOTH()
type shademodel = FLAT | SMOOTH
fun shademodel_to_int FLAT = gl_FLAT
|	shademodel_to_int SMOOTH = gl_SMOOTH
(* StencilOp *)
(*      GL_ZERO *)
val gl_KEEP = def_GL_KEEP()
val gl_REPLACE = def_GL_REPLACE()
val gl_INCR = def_GL_INCR()
val gl_DECR = def_GL_DECR()
(*      GL_INVERT *)
type stencilop
	= S_ZERO
	| KEEP
	| REPLACE
	| INCR
	| DECR
	| S_INVERT
fun stencilop_to_int S_ZERO = gl_ZERO
|	stencilop_to_int KEEP = gl_KEEP
|	stencilop_to_int REPLACE = gl_REPLACE
|	stencilop_to_int INCR = gl_INCR
|	stencilop_to_int DECR = gl_DECR
|	stencilop_to_int S_INVERT = gl_INVERT
(* StringName *)
val gl_VENDOR = def_GL_VENDOR()
val gl_RENDERER = def_GL_RENDERER()
val gl_VERSION = def_GL_VERSION()
val gl_EXTENSIONS = def_GL_EXTENSIONS()
type stringname = VENDOR | RENDERER | VERSION | EXTENSIONS
fun stringname_to_int VENDOR = gl_VENDOR
|	stringname_to_int RENDERER = gl_RENDERER
|	stringname_to_int VERSION = gl_VERSION
|	stringname_to_int EXTENSIONS = gl_EXTENSIONS
(* TextureCoordName *)
val gl_S = def_GL_S()
val gl_T = def_GL_T()
val gl_R = def_GL_R()
val gl_Q = def_GL_Q()
type texcoord = S | T | R | Q
fun texcoord_to_int S = gl_S
|	texcoord_to_int T = gl_T
|	texcoord_to_int R = gl_R
|	texcoord_to_int Q = gl_Q
(* TextureEnvMode *)
val gl_MODULATE = def_GL_MODULATE()
val gl_DECAL = def_GL_DECAL()
(*      GL_BLEND *)
(*      GL_REPLACE *)
(* TextureEnvParameter *)
val gl_TEXTURE_ENV_MODE = def_GL_TEXTURE_ENV_MODE()
val gl_TEXTURE_ENV_COLOR = def_GL_TEXTURE_ENV_COLOR()
type texenvparam = TEXTURE_ENV_MODE | TEXTURE_ENV_COLOR
fun texenvparam_to_int TEXTURE_ENV_MODE = gl_TEXTURE_ENV_MODE
|	texenvparam_to_int TEXTURE_ENV_COLOR = gl_TEXTURE_ENV_COLOR
(* TextureEnvTarget *)
val gl_TEXTURE_ENV = def_GL_TEXTURE_ENV()
type texenvtarget = TEXTURE_ENV
fun texenvtarget_to_int TEXTURE_ENV = gl_TEXTURE_ENV
(* TextureGenMode *)
val gl_EYE_LINEAR = def_GL_EYE_LINEAR()
val gl_OBJECT_LINEAR = def_GL_OBJECT_LINEAR()
val gl_SPHERE_MAP = def_GL_SPHERE_MAP()
type texgenmode = EYE_LINEAR | OBJECT_LINEAR | SPHERE_MAP
fun texgenmode_to_int EYE_LINEAR = gl_EYE_LINEAR
|	texgenmode_to_int OBJECT_LINEAR = gl_OBJECT_LINEAR
|	texgenmode_to_int SPHERE_MAP = gl_SPHERE_MAP
(* TextureGenParameter *)
val gl_TEXTURE_GEN_MODE = def_GL_TEXTURE_GEN_MODE()
val gl_OBJECT_PLANE = def_GL_OBJECT_PLANE()
val gl_EYE_PLANE = def_GL_EYE_PLANE()
type texgenparam = TEXTURE_GEN_MODE | OBJECT_PLANE | EYE_PLANE
fun texgenparam_to_int TEXTURE_GEN_MODE = gl_TEXTURE_GEN_MODE
|	texgenparam_to_int OBJECT_PLANE = gl_OBJECT_PLANE
|	texgenparam_to_int EYE_PLANE = gl_EYE_PLANE
(* TextureMagFilter *)
val gl_NEAREST = def_GL_NEAREST()
val gl_LINEAR = def_GL_LINEAR()
(* TextureMinFilter *)
(*      GL_NEAREST *)
(*      GL_LINEAR *)
val gl_NEAREST_MIPMAP_NEAREST = def_GL_NEAREST_MIPMAP_NEAREST()
val gl_LINEAR_MIPMAP_NEAREST = def_GL_LINEAR_MIPMAP_NEAREST()
val gl_NEAREST_MIPMAP_LINEAR = def_GL_NEAREST_MIPMAP_LINEAR()
val gl_LINEAR_MIPMAP_LINEAR = def_GL_LINEAR_MIPMAP_LINEAR()
type texfilter
	= NEAREST
	| LINEAR
	| NEAREST_MIPMAP_NEAREST
	| LINEAR_MIPMAP_NEAREST
	| NEAREST_MIPMAP_LINEAR
	| LINEAR_MIPMAP_LINEAR
fun texfilter_to_int NEAREST = gl_NEAREST
|	texfilter_to_int LINEAR = gl_LINEAR
|	texfilter_to_int NEAREST_MIPMAP_NEAREST = gl_NEAREST_MIPMAP_NEAREST
|	texfilter_to_int LINEAR_MIPMAP_NEAREST = gl_LINEAR_MIPMAP_NEAREST
|	texfilter_to_int NEAREST_MIPMAP_LINEAR = gl_NEAREST_MIPMAP_LINEAR
|	texfilter_to_int LINEAR_MIPMAP_LINEAR = gl_LINEAR_MIPMAP_LINEAR
(* TextureWrapMode *)
val gl_CLAMP = def_GL_CLAMP()
val gl_REPEAT = def_GL_REPEAT()
type texwrapmode = CLAMP | REPEAT
fun texwrapmode_to_int CLAMP = gl_CLAMP
|	texwrapmode_to_int REPEAT = gl_REPEAT
(* TextureParameterName *)
val gl_TEXTURE_MAG_FILTER = def_GL_TEXTURE_MAG_FILTER()
val gl_TEXTURE_MIN_FILTER = def_GL_TEXTURE_MIN_FILTER()
val gl_TEXTURE_WRAP_S = def_GL_TEXTURE_WRAP_S()
val gl_TEXTURE_WRAP_T = def_GL_TEXTURE_WRAP_T()
(*      GL_TEXTURE_BORDER_COLOR *)
(*      GL_TEXTURE_PRIORITY *)
type texparam
= MAG_FILTER of texfilter
| MIN_FILTER of texfilter
| WRAP_S of texwrapmode
| WRAP_T of texwrapmode
| BORDER_COLOR of real array
| PRIORITY of real
(* FogMode *)
(*      GL_LINEAR *)
val gl_EXP = def_GL_EXP()
val gl_EXP2 = def_GL_EXP2()
type fogmode = F_LINEAR | EXP | EXP2
fun fogmode_to_int F_LINEAR = gl_LINEAR
|	fogmode_to_int EXP = gl_EXP
|	fogmode_to_int EXP2 = gl_EXP2
(* FogParameter *)
(*      GL_FOG_COLOR *)
(*      GL_FOG_DENSITY *)
(*      GL_FOG_END *)
(*      GL_FOG_INDEX *)
(*      GL_FOG_MODE *)
(*      GL_FOG_START *)
type fogparam
	= FOG_COLOR
	| FOG_DENSITY
	| FOG_END
	| FOG_INDEX
	| FOG_MODE
fun fogparam_to_int FOG_COLOR = gl_FOG_COLOR
|	fogparam_to_int FOG_DENSITY = gl_FOG_DENSITY
|	fogparam_to_int FOG_END = gl_FOG_END
|	fogparam_to_int FOG_INDEX = gl_FOG_INDEX
|	fogparam_to_int FOG_MODE = gl_FOG_MODE
(* ClientAttribMask *)
val gl_CLIENT_PIXEL_STORE_BIT = def_GL_CLIENT_PIXEL_STORE_BIT()
val gl_CLIENT_VERTEX_ARRAY_BIT = def_GL_CLIENT_VERTEX_ARRAY_BIT()
val gl_CLIENT_ALL_ATTRIB_BITS = def_GL_CLIENT_ALL_ATTRIB_BITS()
type clientattribmask
	= CLIENT_PIXEL_STORE_BIT
	| CLIENT_VERTEX_ARRAY_BIT
	| CLIENT_ALL_ATTRIB_BITS
fun clientattribmask_to_int CLIENT_PIXEL_STORE_BIT = gl_CLIENT_PIXEL_STORE_BIT
|	clientattribmask_to_int CLIENT_VERTEX_ARRAY_BIT = gl_CLIENT_VERTEX_ARRAY_BIT
|	clientattribmask_to_int CLIENT_ALL_ATTRIB_BITS = gl_CLIENT_ALL_ATTRIB_BITS
(* polygon_offset *)
val gl_POLYGON_OFFSET_FACTOR = def_GL_POLYGON_OFFSET_FACTOR()
val gl_POLYGON_OFFSET_UNITS = def_GL_POLYGON_OFFSET_UNITS()
val gl_POLYGON_OFFSET_POINT = def_GL_POLYGON_OFFSET_POINT()
val gl_POLYGON_OFFSET_LINE = def_GL_POLYGON_OFFSET_LINE()
val gl_POLYGON_OFFSET_FILL = def_GL_POLYGON_OFFSET_FILL()
type polygonoffset
	= POLYGON_OFFSET_FACTOR
	| POLYGON_OFFSET_UNITS
	| POLYGON_OFFSET_POINT
	| POLYGON_OFFSET_LINE
	| POLYGON_OFFSET_FILL
fun polygonoffset POLYGON_OFFSET_FACTOR = gl_POLYGON_OFFSET_FACTOR
|	polygonoffset POLYGON_OFFSET_UNITS = gl_POLYGON_OFFSET_UNITS
|	polygonoffset POLYGON_OFFSET_POINT = gl_POLYGON_OFFSET_POINT
|	polygonoffset POLYGON_OFFSET_LINE = gl_POLYGON_OFFSET_LINE
|	polygonoffset POLYGON_OFFSET_FILL = gl_POLYGON_OFFSET_FILL
(* texture *)
val gl_ALPHA4 = def_GL_ALPHA4()
val gl_ALPHA8 = def_GL_ALPHA8()
val gl_ALPHA12 = def_GL_ALPHA12()
val gl_ALPHA16 = def_GL_ALPHA16()
val gl_LUMINANCE4 = def_GL_LUMINANCE4()
val gl_LUMINANCE8 = def_GL_LUMINANCE8()
val gl_LUMINANCE12 = def_GL_LUMINANCE12()
val gl_LUMINANCE16 = def_GL_LUMINANCE16()
val gl_LUMINANCE4_ALPHA4 = def_GL_LUMINANCE4_ALPHA4()
val gl_LUMINANCE6_ALPHA2 = def_GL_LUMINANCE6_ALPHA2()
val gl_LUMINANCE8_ALPHA8 = def_GL_LUMINANCE8_ALPHA8()
val gl_LUMINANCE12_ALPHA4 = def_GL_LUMINANCE12_ALPHA4()
val gl_LUMINANCE12_ALPHA12 = def_GL_LUMINANCE12_ALPHA12()
val gl_LUMINANCE16_ALPHA16 = def_GL_LUMINANCE16_ALPHA16()
val gl_INTENSITY = def_GL_INTENSITY()
val gl_INTENSITY4 = def_GL_INTENSITY4()
val gl_INTENSITY8 = def_GL_INTENSITY8()
val gl_INTENSITY12 = def_GL_INTENSITY12()
val gl_INTENSITY16 = def_GL_INTENSITY16()
val gl_R3_G3_B2 = def_GL_R3_G3_B2()
val gl_RGB4 = def_GL_RGB4()
val gl_RGB5 = def_GL_RGB5()
val gl_RGB8 = def_GL_RGB8()
val gl_RGB10 = def_GL_RGB10()
val gl_RGB12 = def_GL_RGB12()
val gl_RGB16 = def_GL_RGB16()
val gl_RGBA2 = def_GL_RGBA2()
val gl_RGBA4 = def_GL_RGBA4()
val gl_RGB5_A1 = def_GL_RGB5_A1()
val gl_RGBA8 = def_GL_RGBA8()
val gl_RGB10_A2 = def_GL_RGB10_A2()
val gl_RGBA12 = def_GL_RGBA12()
val gl_RGBA16 = def_GL_RGBA16()

val gl_TEXTURE_RED_SIZE = def_GL_TEXTURE_RED_SIZE()
val gl_TEXTURE_GREEN_SIZE = def_GL_TEXTURE_GREEN_SIZE()
val gl_TEXTURE_BLUE_SIZE = def_GL_TEXTURE_BLUE_SIZE()
val gl_TEXTURE_ALPHA_SIZE = def_GL_TEXTURE_ALPHA_SIZE()
val gl_TEXTURE_LUMINANCE_SIZE = def_GL_TEXTURE_LUMINANCE_SIZE()
val gl_TEXTURE_INTENSITY_SIZE = def_GL_TEXTURE_INTENSITY_SIZE()
val gl_PROXY_TEXTURE_1D = def_GL_PROXY_TEXTURE_1D()
val gl_PROXY_TEXTURE_2D = def_GL_PROXY_TEXTURE_2D()
(* TextureTarget *)
(*      GL_TEXTURE_1D *)
(*      GL_TEXTURE_2D *)
(*      GL_PROXY_TEXTURE_1D *)
(*      GL_PROXY_TEXTURE_2D *)
type textarget
	= TEXTURE_1D
	| TEXTURE_2D
	| PROXY_TEXTURE_1D
	| PROXY_TEXTURE_2D
fun textarget_to_int TEXTURE_1D = gl_TEXTURE_1D
|	textarget_to_int TEXTURE_2D = gl_TEXTURE_2D
|	textarget_to_int PROXY_TEXTURE_1D = gl_PROXY_TEXTURE_1D
|	textarget_to_int PROXY_TEXTURE_2D = gl_PROXY_TEXTURE_2D
(* vertex_array *)
val gl_VERTEX_ARRAY = def_GL_VERTEX_ARRAY()
val gl_NORMAL_ARRAY = def_GL_NORMAL_ARRAY()
val gl_COLOR_ARRAY = def_GL_COLOR_ARRAY()
val gl_INDEX_ARRAY = def_GL_INDEX_ARRAY()
val gl_TEXTURE_COORD_ARRAY = def_GL_TEXTURE_COORD_ARRAY()
val gl_EDGE_FLAG_ARRAY = def_GL_EDGE_FLAG_ARRAY()
val gl_VERTEX_ARRAY_SIZE = def_GL_VERTEX_ARRAY_SIZE()
val gl_VERTEX_ARRAY_TYPE = def_GL_VERTEX_ARRAY_TYPE()
val gl_VERTEX_ARRAY_STRIDE = def_GL_VERTEX_ARRAY_STRIDE()
val gl_NORMAL_ARRAY_TYPE = def_GL_NORMAL_ARRAY_TYPE()
val gl_NORMAL_ARRAY_STRIDE = def_GL_NORMAL_ARRAY_STRIDE()
val gl_COLOR_ARRAY_SIZE = def_GL_COLOR_ARRAY_SIZE()
val gl_COLOR_ARRAY_TYPE = def_GL_COLOR_ARRAY_TYPE()
val gl_COLOR_ARRAY_STRIDE = def_GL_COLOR_ARRAY_STRIDE()
val gl_INDEX_ARRAY_TYPE = def_GL_INDEX_ARRAY_TYPE()
val gl_INDEX_ARRAY_STRIDE = def_GL_INDEX_ARRAY_STRIDE()
val gl_TEXTURE_COORD_ARRAY_SIZE = def_GL_TEXTURE_COORD_ARRAY_SIZE()
val gl_TEXTURE_COORD_ARRAY_TYPE = def_GL_TEXTURE_COORD_ARRAY_TYPE()
val gl_TEXTURE_COORD_ARRAY_STRIDE = def_GL_TEXTURE_COORD_ARRAY_STRIDE()
val gl_EDGE_FLAG_ARRAY_STRIDE = def_GL_EDGE_FLAG_ARRAY_STRIDE()
val gl_VERTEX_ARRAY_POINTER = def_GL_VERTEX_ARRAY_POINTER()
val gl_NORMAL_ARRAY_POINTER = def_GL_NORMAL_ARRAY_POINTER()
val gl_COLOR_ARRAY_POINTER = def_GL_COLOR_ARRAY_POINTER()
val gl_INDEX_ARRAY_POINTER = def_GL_INDEX_ARRAY_POINTER()
val gl_TEXTURE_COORD_ARRAY_POINTER = def_GL_TEXTURE_COORD_ARRAY_POINTER()
val gl_EDGE_FLAG_ARRAY_POINTER = def_GL_EDGE_FLAG_ARRAY_POINTER()
val gl_V2F = def_GL_V2F()
val gl_V3F = def_GL_V3F()
val gl_C4UB_V2F = def_GL_C4UB_V2F()
val gl_C4UB_V3F = def_GL_C4UB_V3F()
val gl_C3F_V3F = def_GL_C3F_V3F()
val gl_N3F_V3F = def_GL_N3F_V3F()
val gl_C4F_N3F_V3F = def_GL_C4F_N3F_V3F()
val gl_T2F_V3F = def_GL_T2F_V3F()
val gl_T4F_V4F = def_GL_T4F_V4F()
val gl_T2F_C4UB_V3F = def_GL_T2F_C4UB_V3F()
val gl_T2F_C3F_V3F = def_GL_T2F_C3F_V3F()
val gl_T2F_N3F_V3F = def_GL_T2F_N3F_V3F()
val gl_T2F_C4F_N3F_V3F = def_GL_T2F_C4F_N3F_V3F()
val gl_T4F_C4F_N3F_V4F = def_GL_T4F_C4F_N3F_V4F()
(* ClientArrayType *)
(*      GL_VERTEX_ARRAY *)
(*      GL_NORMAL_ARRAY *)
(*      GL_COLOR_ARRAY *)
(*      GL_INDEX_ARRAY *)
(*      GL_TEXTURE_COORD_ARRAY *)
(*      GL_EDGE_FLAG_ARRAY *)
type carray
	= VERTEX
	| NORMAL
	| COLOR
	| INDEX
	| TEXTURE_COORD
	| EDGE_FLAG
fun carray_to_int VERTEX = gl_VERTEX_ARRAY
|	carray_to_int NORMAL = gl_NORMAL_ARRAY
|	carray_to_int COLOR = gl_COLOR_ARRAY
|	carray_to_int INDEX = gl_INDEX_ARRAY
|	carray_to_int TEXTURE_COORD = gl_TEXTURE_COORD_ARRAY
|	carray_to_int EDGE_FLAG = gl_EDGE_FLAG_ARRAY
(* Enable *)
(*      GL_FOG *)
(*      GL_LIGHTING *)
(*      GL_TEXTURE_1D *)
(*      GL_TEXTURE_2D *)
(*      GL_LINE_STIPPLE *)
(*      GL_POLYGON_STIPPLE *)
(*      GL_CULL_FACE *)
(*      GL_ALPHA_TEST *)
(*      GL_BLEND *)
(*      GL_INDEX_LOGIC_OP *)
(*      GL_COLOR_LOGIC_OP *)
(*      GL_DITHER *)
(*      GL_STENCIL_TEST *)
(*      GL_DEPTH_TEST *)
(*      GL_CLIP_PLANE0 *)
(*      GL_CLIP_PLANE1 *)
(*      GL_CLIP_PLANE2 *)
(*      GL_CLIP_PLANE3 *)
(*      GL_CLIP_PLANE4 *)
(*      GL_CLIP_PLANE5 *)
(*      GL_LIGHT0 *)
(*      GL_LIGHT1 *)
(*      GL_LIGHT2 *)
(*      GL_LIGHT3 *)
(*      GL_LIGHT4 *)
(*      GL_LIGHT5 *)
(*      GL_LIGHT6 *)
(*      GL_LIGHT7 *)
(*      GL_TEXTURE_GEN_S *)
(*      GL_TEXTURE_GEN_T *)
(*      GL_TEXTURE_GEN_R *)
(*      GL_TEXTURE_GEN_Q *)
(*      GL_MAP1_VERTEX_3 *)
(*      GL_MAP1_VERTEX_4 *)
(*      GL_MAP1_COLOR_4 *)
(*      GL_MAP1_INDEX *)
(*      GL_MAP1_NORMAL *)
(*      GL_MAP1_TEXTURE_COORD_1 *)
(*      GL_MAP1_TEXTURE_COORD_2 *)
(*      GL_MAP1_TEXTURE_COORD_3 *)
(*      GL_MAP1_TEXTURE_COORD_4 *)
(*      GL_MAP2_VERTEX_3 *)
(*      GL_MAP2_VERTEX_4 *)
(*      GL_MAP2_COLOR_4 *)
(*      GL_MAP2_INDEX *)
(*      GL_MAP2_NORMAL *)
(*      GL_MAP2_TEXTURE_COORD_1 *)
(*      GL_MAP2_TEXTURE_COORD_2 *)
(*      GL_MAP2_TEXTURE_COORD_3 *)
(*      GL_MAP2_TEXTURE_COORD_4 *)
(*      GL_POINT_SMOOTH *)
(*      GL_LINE_SMOOTH *)
(*      GL_POLYGON_SMOOTH *)
(*      GL_SCISSOR_TEST *)
(*      GL_COLOR_MATERIAL *)
(*      GL_NORMALIZE *)
(*      GL_AUTO_NORMAL *)
(*      GL_VERTEX_ARRAY *)
(*      GL_NORMAL_ARRAY *)
(*      GL_COLOR_ARRAY *)
(*      GL_INDEX_ARRAY *)
(*      GL_TEXTURE_COORD_ARRAY *)
(*      GL_EDGE_FLAG_ARRAY *)
(*      GL_POLYGON_OFFSET_POINT *)
(*      GL_POLYGON_OFFSET_LINE *)
(*      GL_POLYGON_OFFSET_FILL *)
type edparam
	= FOG
	| LIGHTING
	| TEX of textarget
	| LINE_STIPPLE
	| POLYGON_STIPPLE
	| CULL_FACE
	| ALPHA_TEST
	| BLEND
	| INDEX_LOGIC_OP
	| COLOR_LOGIC_OP
	| DITHER
	| STENCIL_TEST
	| DEPTH_TEST
	| CLIP of planename
	| LIGHT of lightname
	| TEXTURE_GEN_S
	| TEXTURE_GEN_T
	| TEXTURE_GEN_R
	| TEXTURE_GEN_Q
	| MAP1 of map1target
	| MAP2 of map2target
	| POINT_SMOOTH
	| LINE_SMOOTH
	| POLYGON_SMOOTH
	| SCISSOR_TEST
	| COLOR_MATERIAL
	| NORMALIZE
	| AUTO_NORMAL
	| ARRAY of carray
	| POLYGON_OFFSET_POINT
	| POLYGON_OFFSET_LINE
	| POLYGON_OFFSET_FILL
fun edparam_to_int FOG = gl_FOG
|	edparam_to_int LIGHTING = gl_LIGHTING
|	edparam_to_int (TEX t) = textarget_to_int t
|	edparam_to_int LINE_STIPPLE = gl_LINE_STIPPLE
|	edparam_to_int POLYGON_STIPPLE = gl_POLYGON_STIPPLE
|	edparam_to_int CULL_FACE = gl_CULL_FACE
|	edparam_to_int ALPHA_TEST = gl_ALPHA_TEST
|	edparam_to_int BLEND = gl_BLEND
|	edparam_to_int INDEX_LOGIC_OP = gl_INDEX_LOGIC_OP
|	edparam_to_int COLOR_LOGIC_OP = gl_COLOR_LOGIC_OP
|	edparam_to_int DITHER = gl_DITHER
|	edparam_to_int STENCIL_TEST = gl_STENCIL_TEST
|	edparam_to_int DEPTH_TEST = gl_DEPTH_TEST
|	edparam_to_int CLIP pn = planename_to_int pn
|	edparam_to_int LIGHT ln = lightname_to_int ln
|	edparam_to_int TEXTURE_GEN_S = gl_TEXTURE_GEN_S
|	edparam_to_int TEXTURE_GEN_T = gl_TEXTURE_GEN_T
|	edparam_to_int TEXTURE_GEN_R = gl_TEXTURE_GEN_R
|	edparam_to_int TEXTURE_GEN_Q = gl_TEXTURE_GEN_Q
|	edparam_to_int (MAP1 m1) = map1target_to_int m1
|	edparam_to_int (MAP2 m2) = map2target_to_int m2
|	edparam_to_int POINT_SMOOTH = gl_POINT_SMOOTH
|	edparam_to_int LINE_SMOOTH = gl_LINE_SMOOTH
|	edparam_to_int POLYGON_SMOOTH = gl_POLYGON_SMOOTH
|	edparam_to_int SCISSOR_TEST = gl_SCISSOR_TEST
|	edparam_to_int COLOR_MATERIAL = gl_COLOR_MATERIAL
|	edparam_to_int NORMALIZE = gl_NORMALIZE
|	edparam_to_int AUTO_NORMAL = gl_AUTO_NORMAL
|	edparam_to_int (ARRAY ca) = carray_to_int ca
|	edparam_to_int POLYGON_OFFSET_POINT = gl_POLYGON_OFFSET_POINT
|	edparam_to_int POLYGON_OFFSET_LINE = gl_POLYGON_OFFSET_LINE
|	edparam_to_int POLYGON_OFFSET_FILL = gl_POLYGON_OFFSET_FILL
(* Extensions *)
val gl_EXT_vertex_array = def_GL_EXT_vertex_array()
val gl_EXT_bgra = def_GL_EXT_bgra()
val gl_EXT_paletted_texture = def_GL_EXT_paletted_texture()
//val gl_WIN_swap_hint = def_GL_WIN_swap_hint()
//val gl_WIN_draw_range_elements = def_GL_WIN_draw_range_elements()
(* #define GL_WIN_phong_shading              1 *)
(* #define GL_WIN_specular_fog               1 *)
(* EXT_vertex_array *)
val gl_VERTEX_ARRAY_EXT = def_GL_VERTEX_ARRAY_EXT()
val gl_NORMAL_ARRAY_EXT = def_GL_NORMAL_ARRAY_EXT()
val gl_COLOR_ARRAY_EXT = def_GL_COLOR_ARRAY_EXT()
val gl_INDEX_ARRAY_EXT = def_GL_INDEX_ARRAY_EXT()
val gl_TEXTURE_COORD_ARRAY_EXT = def_GL_TEXTURE_COORD_ARRAY_EXT()
val gl_EDGE_FLAG_ARRAY_EXT = def_GL_EDGE_FLAG_ARRAY_EXT()
val gl_VERTEX_ARRAY_SIZE_EXT = def_GL_VERTEX_ARRAY_SIZE_EXT()
val gl_VERTEX_ARRAY_TYPE_EXT = def_GL_VERTEX_ARRAY_TYPE_EXT()
val gl_VERTEX_ARRAY_STRIDE_EXT = def_GL_VERTEX_ARRAY_STRIDE_EXT()
val gl_VERTEX_ARRAY_COUNT_EXT = def_GL_VERTEX_ARRAY_COUNT_EXT()
val gl_NORMAL_ARRAY_TYPE_EXT = def_GL_NORMAL_ARRAY_TYPE_EXT()
val gl_NORMAL_ARRAY_STRIDE_EXT = def_GL_NORMAL_ARRAY_STRIDE_EXT()
val gl_NORMAL_ARRAY_COUNT_EXT = def_GL_NORMAL_ARRAY_COUNT_EXT()
val gl_COLOR_ARRAY_SIZE_EXT = def_GL_COLOR_ARRAY_SIZE_EXT()
val gl_COLOR_ARRAY_TYPE_EXT = def_GL_COLOR_ARRAY_TYPE_EXT()
val gl_COLOR_ARRAY_STRIDE_EXT = def_GL_COLOR_ARRAY_STRIDE_EXT()
val gl_COLOR_ARRAY_COUNT_EXT = def_GL_COLOR_ARRAY_COUNT_EXT()
val gl_INDEX_ARRAY_TYPE_EXT = def_GL_INDEX_ARRAY_TYPE_EXT()
val gl_INDEX_ARRAY_STRIDE_EXT = def_GL_INDEX_ARRAY_STRIDE_EXT()
val gl_INDEX_ARRAY_COUNT_EXT = def_GL_INDEX_ARRAY_COUNT_EXT()
val gl_TEXTURE_COORD_ARRAY_SIZE_EXT = def_GL_TEXTURE_COORD_ARRAY_SIZE_EXT()
val gl_TEXTURE_COORD_ARRAY_TYPE_EXT = def_GL_TEXTURE_COORD_ARRAY_TYPE_EXT()
val gl_TEXTURE_COORD_ARRAY_STRIDE_EXT = def_GL_TEXTURE_COORD_ARRAY_STRIDE_EXT()
val gl_TEXTURE_COORD_ARRAY_COUNT_EXT = def_GL_TEXTURE_COORD_ARRAY_COUNT_EXT()
val gl_EDGE_FLAG_ARRAY_STRIDE_EXT = def_GL_EDGE_FLAG_ARRAY_STRIDE_EXT()
val gl_EDGE_FLAG_ARRAY_COUNT_EXT = def_GL_EDGE_FLAG_ARRAY_COUNT_EXT()
val gl_VERTEX_ARRAY_POINTER_EXT = def_GL_VERTEX_ARRAY_POINTER_EXT()
val gl_NORMAL_ARRAY_POINTER_EXT = def_GL_NORMAL_ARRAY_POINTER_EXT()
val gl_COLOR_ARRAY_POINTER_EXT = def_GL_COLOR_ARRAY_POINTER_EXT()
val gl_INDEX_ARRAY_POINTER_EXT = def_GL_INDEX_ARRAY_POINTER_EXT()
val gl_TEXTURE_COORD_ARRAY_POINTER_EXT = def_GL_TEXTURE_COORD_ARRAY_POINTER_EXT()
val gl_EDGE_FLAG_ARRAY_POINTER_EXT = def_GL_EDGE_FLAG_ARRAY_POINTER_EXT()
//val gl_DOUBLE_EXT = def_GL_DOUBLE_EXT()
(* EXT_bgra *)
val gl_BGR_EXT = def_GL_BGR_EXT()
val gl_BGRA_EXT = def_GL_BGRA_EXT()
(* EXT_paletted_texture *)
(* These must match the GL_COLOR_TABLE_*_SGI enumerants *)
//val gl_COLOR_TABLE_FORMAT_EXT = def_GL_COLOR_TABLE_FORMAT_EXT()
//val gl_COLOR_TABLE_WIDTH_EXT = def_GL_COLOR_TABLE_WIDTH_EXT()
//val gl_COLOR_TABLE_RED_SIZE_EXT = def_GL_COLOR_TABLE_RED_SIZE_EXT()
//val gl_COLOR_TABLE_GREEN_SIZE_EXT = def_GL_COLOR_TABLE_GREEN_SIZE_EXT()
//val gl_COLOR_TABLE_BLUE_SIZE_EXT = def_GL_COLOR_TABLE_BLUE_SIZE_EXT()
//val gl_COLOR_TABLE_ALPHA_SIZE_EXT = def_GL_COLOR_TABLE_ALPHA_SIZE_EXT()
//val gl_COLOR_TABLE_LUMINANCE_SIZE_EXT = def_GL_COLOR_TABLE_LUMINANCE_SIZE_EXT()
//val gl_COLOR_TABLE_INTENSITY_SIZE_EXT = def_GL_COLOR_TABLE_INTENSITY_SIZE_EXT()
val gl_COLOR_INDEX1_EXT = def_GL_COLOR_INDEX1_EXT()
val gl_COLOR_INDEX2_EXT = def_GL_COLOR_INDEX2_EXT()
val gl_COLOR_INDEX4_EXT = def_GL_COLOR_INDEX4_EXT()
val gl_COLOR_INDEX8_EXT = def_GL_COLOR_INDEX8_EXT()
val gl_COLOR_INDEX12_EXT = def_GL_COLOR_INDEX12_EXT()
val gl_COLOR_INDEX16_EXT = def_GL_COLOR_INDEX16_EXT()
(* WIN_draw_range_elements *)
//val gl_MAX_ELEMENTS_VERTICES_WIN = def_GL_MAX_ELEMENTS_VERTICES_WIN()
//val gl_MAX_ELEMENTS_INDICES_WIN = def_GL_MAX_ELEMENTS_INDICES_WIN()
(* WIN_phong_shading *)
//val gl_PHONG_WIN = def_GL_PHONG_WIN()
//val gl_PHONG_HINT_WIN = def_GL_PHONG_HINT_WIN()
(* WIN_specular_fog *)
//val gl_FOG_SPECULAR_TEXTURE_WIN = def_GL_FOG_SPECULAR_TEXTURE_WIN()

fun accum op = Gl_.accum (accumop_to_int op)
fun alphaFunc func = Gl_.alphaFunc (asdfunc_to_int func)
fun areTexturesResident arr = Gl_.areTexturesResident (Array.length arr) arr
val arrayElement = arrayElement
fun glbegin m = Gl_.glbegin (beginmode_to_int m)
val bindTexture = bindTexture
val bitmap = bitmap
fun blendFunc sf df = Gl_.blendFunc (blendfactor_to_int sf) (blendfactor_to_int df)
val callList = callList
fun callLists arr = Gl_.callLists (Array.length arr) (Array.map float_of_int arr)
fun clear bml =
	let fun bm_to_ni bm = Nativeint.of_int (attribmask_to_int bm)
		val ni = List.fold_left
					Nativeint.logor Nativeint.zero (List.map bm_to_ni bml)
	in Gl_.clear (Nativeint.to_int ni) end
val clearAccum = clearAccum
val clearColor = clearColor
val clearDepth = clearDepth 
val clearIndex = clearIndex
val clearStencil = clearStencil
fun clipPlane n arr = Gl_.clipPlane (planename_to_int n) arr
val color3 = color3
val color4 = color4
val colorMask = colorMask
fun colorMaterial fa m = Gl_.colorMaterial (face_to_int fa) (materialfvparam_to_int m)
val colorPointer3 = colorPointer3 0
val colorPointer4 = colorPointer4 0
fun copyPixels x y w h ct = Gl_.copyPixels x y w h (pixelcopytype_to_int ct)
fun copyTexImage1D lv ifm x y w b = Gl_.copyTexImage1D lv ifm x y w b (* internal format    ߿    ֱ *)
fun copyTexImage2D lv ifm x y w h b = Gl_.copyTexImage2D lv ifm x y w h b (* internal format    ߿    ֱ *)
val copyTexSubImage1D = copyTexSubImage1D
val copyTexSubImage2D = copyTexSubImage2D
fun cullFace m = Gl_.cullFace (face_to_int m)
val deleteLists = deleteLists
fun deleteTextures arr = Gl_.deleteTextures (Array.length arr) arr
fun depthFunc func = Gl_.depthFunc (asdfunc_to_int func)
val depthMask = depthMask
val depthRange = depthRange
fun disable pn = Gl_.disable (edparam_to_int pn)
fun disableClientState ca = Gl_.disableClientState (carray_to_int ca)
fun drawArrays pn = Gl_.drawArrays (edparam_to_int pn)
fun drawBuffer m = Gl_.drawBuffer (buffermode_to_int m)
fun drawElements pn arr =
	Gl_.drawElements
		(edparam_to_int pn) (Array.length arr) (Array.map float_of_int arr)
fun drawPixels w h pf pt = Gl_.drawPixels w h (pixelformat_to_int pf) (pixeltype_to_int pt)
val edgeFlag = edgeFlag
fun edgeFlagPointer arr =
	let	val tostr = fn arr=>
		let val l = List.map (fn b=> if b then '\001' else '\000') arr
			val s = String.create (List.length arr)
			fun tostr [] s _ = s
			|	tostr (c::l) s i = String.set s i c ; tostr l s (i+1)
		in tostr l s 0 end
	in Gl_.edgeFlagPointer 0 (tostr arr) end
fun enable pn = Gl_.enable (edparam_to_int pn)
fun enableClientState ca = Gl_.enableClientState (carray_to_int ca)
val glend = glend
val endList = endList
val evalCoord1d = evalCoord1d 
val evalCoord2d = evalCoord2d 
fun evalMesh1 m = Gl_.evalMesh1 (mpmode_to_int m)
fun evalMesh2 m = Gl_.evalMesh2 (mpmode_to_int m)
val evalPoint1 = evalPoint1
val evalPoint2 = evalPoint2
fun feedbackBuffer m buf = Gl_.feedbackBuffer (String.length buf) (feedbackmode_to_int m) buf
val finish = finish
val flush = flush
fun fogi pn = Gl_.fogi (fogparam_to_int pn)
fun fogf pn = Gl_.fogf (fogparam_to_int pn)
fun fogfv pn = Gl_.fogfv (fogparam_to_int pn)
fun frontFace fd = Gl_.frontFace (fdirection_to_int fd)
val frustum = frustum
val genLists = genLists
fun genTextures n = let val arr = Array.make n 0 in Gl_.genTextures n arr end
val getBoolean = getBoolean
fun getClipPlane n = Gl_.getClipPlane (planename_to_int n) (Array.of_list [0.0,0.0,0.0,0.0])
val getDouble = getDouble
fun getError () = errorcode_of_int (Gl_.getError ())
val getInteger = getInteger
fun getLightf ln pn = Gl_.getLightf (lightname_to_int ln) (lightfparam_to_int pn)
fun getLightfv ln pn =
	let val arr = Array.of_list
				(if pn=SPOT_DIRECTION then [0.0,0.0,0.0] else [0.0,0.0,0.0,0.0])
	in Gl_.getLightfv (lightname_to_int ln) (lightfvparam_to_int pn) arr end
(*val getMap*v ̰  ȸ ̹б⿡ ȸ *)
fun getMaterialf fa pn = Gl_.getMaterialf (face_to_int fa) (materialfparam_to_int pn)
fun getMaterialfv fa pn =
	let val arr = Array.of_list
				(if pn=COLOR_INDEXES then [0.0,0.0,0.0] else [0.0,0.0,0.0,0.0])
	in Gl_.getMaterialfv (face_to_int fa) (materialfvparam_to_int pn) end
(* val getPixelMap*v ̰  ȸ ̹б⿡ ȸ *)
fun getPolygonStipple () = Gl_.getPolygonStipple (String.create (32*32))
fun getString sn = Gl_.getString (stringname_to_int sn)
fun getTexEnvi tg pn = Gl_.getTexEnvi (texenvtarget_to_int tg) (texenvparam_to_int pn)
fun getTexEnvfv tg pn =
	let val arr = [0.0,0.0,0.0]
	in Gl_.getTexEnvfv (texenvtarget_to_int tg) (texenvparam_to_int pn) end
fun getTexGeni co pn = Gl_.getTexGeni (texcoord_to_int co) (texgenparam_to_int pn) (*GL_TEXTURE_GEN_MODE   texgenmode  ´*)
fun getTexGend co pn = Gl_.getTexGend (texcoord_to_int co) (texgenparam_to_int pn)
fun getTexGendv co pn = Gl_.getTexGendv (texcoord_to_int co) (texgenparam_to_int pn) (Array.make 4 0.0)
(*
void glGetTexImage (GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels);
*)
(*val getTexLevelParameterf : int -> int -> int -> real
val getTexLevelParameteri : int -> int -> int -> int
val getTexParameterf : int -> int -> real 
val getTexParameteri : int -> int -> int *)
fun hint pn m = Gl_.hint (hinttarget_to_int pn) (hintmode_to_int m)
val indexMask = indexMask
val indexPointer = indexPointer 0
val index = index
val initNames = initNames
fun isEnabled pn = Gl_.isEnabled (edparam_to_int pn)
val isList = isList
val isTexture = isTexture
fun lightModelfv m = Gl_.lightModelfv (lmparamfv_to_int m)
fun lightModeli m = Gl_.lightModeli (lmparami_to_int m)
fun lightf ln pn = Gl_.lightf (lightname_to_int ln) (lightfparam_to_int pn)
fun lightfv ln pn = Gl_.lightfv (lightname_to_int ln) (lightfvparam_to_int pn)
val lineStipple = lineStipple
val lineWidth = lineWidth
val listBase = listBase
val loadIdentity = loadIdentity
val loadMatrix = loadMatrix
val loadName = loadName
fun logicOp op = Gl_.logicOp (logicop_to_int op)
fun map1 pn = Gl_.map1 (map1target_to_int pn)
fun map2 pn = Gl_.map2 (map2target_to_int pn)
val mapGrid1 = mapGrid1
val mapGrid2 = mapGrid2
fun materialf fa pn = Gl_.materialf (face_to_int fa) (materialfparam_to_int pn)
fun materialfv fa pn = Gl_.materialfv (face_to_int fa) (materialfvparam_to_int pn)
fun matrixMode m = Gl_.matrixMode (matrixmode_to_int m)
val multMatrix = multMatrix
fun newList l m = Gl_.newList l (listmode_to_int m)
val normal3 = normal3
val normalPointer = normalPointer 0
val ortho = ortho
val passThrough = passThrough
fun pixelMapfv m arr = Gl_.pixelMap (pixelmap_to_int m) (Array.length arr) arr
fun pixelMapiv m arr = pixelMapfv m (Array.map float_of_int arr)
fun pixelStorei pn = Gl_.pixelStorei (pixstri_to_int pn)
fun pixelStoreb pn b = Gl_.pixelStorei (pixstrb_to_int pn) (if b then 1 else 0)
fun pixelTransferf pn = Gl_.pixelTransferf (pixtrsf_to_int pn)
fun pixelTransferi pn = Gl_.pixelTransferi (pixtrsi_to_int pn)
fun pixelTransferb pn b = Gl_.pixelTransferi (pixtrsb_to_int pn) (if b then 1 else 0)
val pixelZoom = pixelZoom
val pointSize = pointSize
fun polygonMode fa m = Gl_.polygonMode (face_to_int fa) (mpmode_to_int m)
val polygonOffset = polygonOffset
val polygonStipple = polygonStipple
val popAttrib = popAttrib
val popClientAttrib = popClientAttrib
val popMatrix = popMatrix
val popName = popName
fun prioritizeTextures arr = Gl_.prioritizeTextures (Array.length arr) arr
fun pushAttrib bm = Gl_.pushAttrib (attribmask_to_int bm)
fun pushClientAttrib bm = Gl_.pushClientAttrib (clientattribmask_to_int bm)
val pushMatrix = pushMatrix
val pushName = pushName
val rasterPos2 = rasterPos2
val rasterPos3 = rasterPos3
val rasterPos4 = rasterPos4
fun readBuffer m = Gl_.readBuffer (buffermode_to_int m)
fun readPixels x y w h pf pt = Gl_.readPixels x y w h (pixelformat_to_int pf) (pixeltype_to_int pt) (*  ũ 迭 Ѱ ϴ · Ǿ ֳ ? ũ    ϱ. ߿ ߰ *)
val rect = rect
fun renderMode m = Gl_.renderMode (rendermode_to_int m)
val rotate = rotate
val scale = scale
val scissor = scissor
fun selectBuffer buf = Gl_.selectBuffer (String.length buf) buf
fun shadeModel m = Gl_.shadeModel (shademodel_to_int m)
fun stencilFunc func = Gl_.stencilFunc (asdfunc_to_int func)
val stencilMask = stencilMask
fun stencilOp sf dpf dpp = Gl_.stencilOp (stencilop_to_int sf) (stencilop_to_int dpf) (stencilop_to_int dpp)
val texCoord1 = texCoord1
val texCoord2 = texCoord2
val texCoord3 = texCoord3
val texCoord4 = texCoord4
val texCoordPointer1 = texCoordPointer1 0
val texCoordPointer2 = texCoordPointer2 0
val texCoordPointer3 = texCoordPointer3 0
val texCoordPointer4 = texCoordPointer4 0
fun texEnvi tg pn = Gl_.texEnvi (texenvtarget_to_int tg) (texenvparam_to_int pn) (*   arg  GL_DECAL  enum ̷ !! *)
fun texEnvfv tg pn = Gl_.texEnvfv (texenvtarget_to_int tg) (texenvparam_to_int pn)
fun texGeni co pn = Gl_.texGeni (texcoord_to_int co) (texgenparam_to_int pn) (*GL_TEXTURE_GEN_MODE   texgenmode  ´*)
fun texGend co pn = Gl_.texGend (texcoord_to_int co) (texgenparam_to_int pn)
fun texGendv co pn = Gl_.texGendv (texcoord_to_int co) (texgenparam_to_int pn)
fun texImage1D tg lv ifm w b pf pt = Gl_.texImage1D (textarget_to_int tg) lv ifm w b (pixelformat_to_int pf) (pixeltype_to_int pt) (* internal format    ߿    ֱ  ̹б⿡ ̰  *)
fun texImage2D tg lv ifm w h b pf pt = Gl_.texImage2D (textarget_to_int tg) lv ifm w h b (pixelformat_to_int pf) (pixeltype_to_int pt) (* internal format    ߿    ֱ  ̹б⿡ ̰  *)
fun texParameter tg =
	let val tg = textarget_to_int tg
	in fn MAG_FILTER tf => texParameteri tg gl_TEXTURE_MAG_FILTER (texfilter_to_int tf)
		| MIN_FILTER tf => texParameteri tg gl_TEXTURE_MIN_FILTER (texfilter_to_int tf)
		| WRAP_S tw => texParameteri tg gl_TEXTURE_WRAP_S (texwrapmode_to_int tw)
		| WRAP_T tw => texParameteri tg gl_TEXTURE_WRAP_T (texwrapmode_to_int tw)
		| BORDER_COLOR arr => texParameterfv tg gl_TEXTURE_BORDER_COLOR arr
		| PRIORITY r => texParameterf tg gl_TEXTURE_PRIORITY r
	end
fun texSubImage1D lv x w pf pt = Gl_.texSubImage1D lv x w (pixelformat_to_int pf) (pixeltype_to_int pt)
fun texSubImage2D lv x y w h pf pt = Gl_.texSubImage2D lv x y w h (pixelformat_to_int pf) (pixeltype_to_int pt)
val translate = translate
val vertex2 = vertex2
val vertex3 = vertex3
val vertex4 = vertex4
val vertexPointer2 = vertexPointer2 0
val vertexPointer3 = vertexPointer3 0
val vertexPointer4 = vertexPointer4 0
val viewport = viewport

end
