structure Glut =
struct

open Glut_

(* Display mode bit masks. *)
val glut_RGB		 = def_GLUT_RGB						() 
val glut_RGBA		 = def_GLUT_RGBA						() 
val glut_INDEX		 = def_GLUT_INDEX						() 
val glut_SINGLE		 = def_GLUT_SINGLE					() 
val glut_DOUBLE		 = def_GLUT_DOUBLE					() 
val glut_ACCUM		 = def_GLUT_ACCUM						() 
val glut_ALPHA		 = def_GLUT_ALPHA						() 
val glut_DEPTH		 = def_GLUT_DEPTH						() 
val glut_STENCIL	 = def_GLUT_STENCIL					() 
val glut_MULTISAMPLE = def_GLUT_MULTISAMPLE				() 
val glut_STEREO		 = def_GLUT_STEREO					() 
val glut_LUMINANCE	 = def_GLUT_LUMINANCE					() 
type displaymode
	= RGB
	| RGBA
	| INDEX
	| SINGLE
	| DOUBLE
	| ACCUM
	| ALPHA
	| DEPTH
	| STENCIL
	| MULTISAMPLE
	| STEREO
	| LUMINANCE
fun displaymode_to_int RGB			= glut_RGB		
|	displaymode_to_int RGBA			= glut_RGBA		
|	displaymode_to_int INDEX		= glut_INDEX		
|	displaymode_to_int SINGLE		= glut_SINGLE		
|	displaymode_to_int DOUBLE		= glut_DOUBLE		
|	displaymode_to_int ACCUM		= glut_ACCUM		
|	displaymode_to_int ALPHA		= glut_ALPHA		
|	displaymode_to_int DEPTH		= glut_DEPTH		
|	displaymode_to_int STENCIL		= glut_STENCIL	
|	displaymode_to_int MULTISAMPLE	= glut_MULTISAMPLE
|	displaymode_to_int STEREO		= glut_STEREO		
|	displaymode_to_int LUMINANCE	= glut_LUMINANCE
fun displaymode_of_int n =
	if n=glut_RGB then RGB else
	if n=glut_RGBA then RGBA else
	if n=glut_INDEX then INDEX else
	if n=glut_SINGLE then SINGLE else
	if n=glut_DOUBLE then DOUBLE else
	if n=glut_ACCUM then ACCUM else
	if n=glut_ALPHA then ALPHA else
	if n=glut_DEPTH then DEPTH else
	if n=glut_STENCIL then STENCIL else
	if n=glut_MULTISAMPLE then MULTISAMPLE else
	if n=glut_STEREO then STEREO else
	if n=glut_LUMINANCE then LUMINANCE else
	raise Failure "displaymode_of_int"
(* Mouse buttons. *)
val glut_LEFT_BUTTON	 = def_GLUT_LEFT_BUTTON					() 
val glut_MIDDLE_BUTTON	 = def_GLUT_MIDDLE_BUTTON				() 
val glut_RIGHT_BUTTON	 = def_GLUT_RIGHT_BUTTON				() 
type mousebutton
	= LEFT_BUTTON
	| MIDDLE_BUTTON
	| RIGHT_BUTTON
fun mousebutton_to_int LEFT_BUTTON = glut_LEFT_BUTTON
|	mousebutton_to_int MIDDLE_BUTTON = glut_MIDDLE_BUTTON
|	mousebutton_to_int RIGHT_BUTTON = glut_RIGHT_BUTTON
fun mousebutton_of_int n =
	if n=glut_LEFT_BUTTON then LEFT_BUTTON else
	if n=glut_MIDDLE_BUTTON then MIDDLE_BUTTON else
	if n=glut_RIGHT_BUTTON then RIGHT_BUTTON else
	raise Failure "mousebutton_of_int"
(* Mouse button  state. *)
val glut_DOWN = def_GLUT_DOWN					() 
val glut_UP	  = def_GLUT_UP						()
type mousebuttonstate = DOWN | UP
fun mousebuttonstate_to_int UP = glut_UP
|	mousebuttonstate_to_int DOWN = glut_DOWN
fun mousebuttonstate_of_int n =
	if n=glut_UP then UP else
	if n=glut_DOWN then DOWN else
	raise Failure "mousebuttonstate_of_int"
(* function keys *)                         
val glut_KEY_F1  = def_GLUT_KEY_F1					() 
val glut_KEY_F2  = def_GLUT_KEY_F2					() 
val glut_KEY_F3  = def_GLUT_KEY_F3					() 
val glut_KEY_F4  = def_GLUT_KEY_F4					() 
val glut_KEY_F5  = def_GLUT_KEY_F5					() 
val glut_KEY_F6  = def_GLUT_KEY_F6					() 
val glut_KEY_F7  = def_GLUT_KEY_F7					() 
val glut_KEY_F8  = def_GLUT_KEY_F8					() 
val glut_KEY_F9  = def_GLUT_KEY_F9					() 
val glut_KEY_F10 = def_GLUT_KEY_F10					() 
val glut_KEY_F11 = def_GLUT_KEY_F11					() 
val glut_KEY_F12 = def_GLUT_KEY_F12					() 
(* directional keys *)                      
val glut_KEY_LEFT		 = def_GLUT_KEY_LEFT				() 
val glut_KEY_UP			 = def_GLUT_KEY_UP					() 
val glut_KEY_RIGHT		 = def_GLUT_KEY_RIGHT				() 
val glut_KEY_DOWN		 = def_GLUT_KEY_DOWN				() 
val glut_KEY_PAGE_UP	 = def_GLUT_KEY_PAGE_UP				() 
val glut_KEY_PAGE_DOWN	 = def_GLUT_KEY_PAGE_DOWN			() 
val glut_KEY_HOME		 = def_GLUT_KEY_HOME				() 
val glut_KEY_END		 = def_GLUT_KEY_END					() 
val glut_KEY_INSERT		 = def_GLUT_KEY_INSERT				() 
type specialkey
	= KEY_F1		
	| KEY_F2        
	| KEY_F3        
	| KEY_F4        
	| KEY_F5        
	| KEY_F6        
	| KEY_F7        
	| KEY_F8        
	| KEY_F9        
	| KEY_F10       
	| KEY_F11       
	| KEY_F12       
	| KEY_LEFT		
	| KEY_UP		
	| KEY_RIGHT		
	| KEY_DOWN		
	| KEY_PAGE_UP	
	| KEY_PAGE_DOWN	
	| KEY_HOME		
	| KEY_END		
	| KEY_INSERT	
fun specialkey_to_int KEY_F1  		  = glut_KEY_F1			
|	specialkey_to_int KEY_F2       	  = glut_KEY_F2            
|	specialkey_to_int KEY_F3          = glut_KEY_F3            
|	specialkey_to_int KEY_F4          = glut_KEY_F4            
|	specialkey_to_int KEY_F5          = glut_KEY_F5            
|	specialkey_to_int KEY_F6          = glut_KEY_F6            
|	specialkey_to_int KEY_F7          = glut_KEY_F7            
|	specialkey_to_int KEY_F8          = glut_KEY_F8            
|	specialkey_to_int KEY_F9          = glut_KEY_F9            
|	specialkey_to_int KEY_F10         = glut_KEY_F10           
|	specialkey_to_int KEY_F11         = glut_KEY_F11           
|	specialkey_to_int KEY_F12         = glut_KEY_F12           
|	specialkey_to_int KEY_LEFT		  = glut_KEY_LEFT		    
|	specialkey_to_int KEY_UP		  = glut_KEY_UP			
|	specialkey_to_int KEY_RIGHT	      = glut_KEY_RIGHT		 	
|	specialkey_to_int KEY_DOWN		  = glut_KEY_DOWN		    
|	specialkey_to_int KEY_PAGE_UP	  = glut_KEY_PAGE_UP	    
|	specialkey_to_int KEY_PAGE_DOWN   = glut_KEY_PAGE_DOWN	 	
|	specialkey_to_int KEY_HOME		  = glut_KEY_HOME		    
|	specialkey_to_int KEY_END		  = glut_KEY_END		    
|	specialkey_to_int KEY_INSERT	  = glut_KEY_INSERT		
fun specialkey_of_int n =
	if n=glut_KEY_F1 then KEY_F1 else
	if n=glut_KEY_F2 then KEY_F2 else
	if n=glut_KEY_F3 then KEY_F3 else
	if n=glut_KEY_F4 then KEY_F4 else
	if n=glut_KEY_F5 then KEY_F5 else
	if n=glut_KEY_F6 then KEY_F6 else
	if n=glut_KEY_F7 then KEY_F7 else
	if n=glut_KEY_F8 then KEY_F8 else
	if n=glut_KEY_F9 then KEY_F9 else
	if n=glut_KEY_F10 then KEY_F10 else
	if n=glut_KEY_F11 then KEY_F11 else
	if n=glut_KEY_F12 then KEY_F12 else
    if n=glut_KEY_LEFT then KEY_LEFT else
	if n=glut_KEY_UP then KEY_UP else
    if n=glut_KEY_RIGHT then KEY_RIGHT else
    if n=glut_KEY_DOWN then KEY_DOWN else
	if n=glut_KEY_PAGE_UP then KEY_PAGE_UP else
	if n=glut_KEY_PAGE_DOWN then KEY_PAGE_DOWN else
	if n=glut_KEY_HOME then KEY_HOME else
	if n=glut_KEY_END then KEY_END else
	if n=glut_KEY_INSERT then KEY_INSERT else
	raise Failure "specialkey_of_int"

(* Entry/exit  state. *) 
val glut_LEFT	 = def_GLUT_LEFT					() 
val glut_ENTERED = def_GLUT_ENTERED					() 
type entrystate = LEFT | ENTERED
fun entrystate_to_int LEFT = glut_LEFT
|	entrystate_to_int ENTERED = glut_ENTERED
fun entrystate_of_int n =
	if n=glut_LEFT then LEFT else
	if n=glut_ENTERED then ENTERED else
	raise Failure "Glut.entrystate_of_int"
(* Menu usage  state. *)                    
val glut_MENU_NOT_IN_USE	 = def_GLUT_MENU_NOT_IN_USE			() 
val glut_MENU_IN_USE		 = def_GLUT_MENU_IN_USE				()
type menustate = NOT_IN_USE | IN_USE
fun menustate_to_int NOT_IN_USE = glut_MENU_NOT_IN_USE
|	menustate_to_int IN_USE = glut_MENU_IN_USE
fun menustate_of_int n =
	if n=glut_MENU_IN_USE then IN_USE else
	if n=glut_MENU_NOT_IN_USE then NOT_IN_USE else
	raise Failure "menustate_of_int"
(* Visibility  state. *)                    
val glut_NOT_VISIBLE	 = def_GLUT_NOT_VISIBLE				() 
val glut_VISIBLE		 = def_GLUT_VISIBLE					()
type visiblestate = NOT_VISIBLE | VISIBLE
fun visiblestate_to_int NOT_VISIBLE = glut_NOT_VISIBLE
|	visiblestate_to_int VISIBLE = glut_VISIBLE
fun visiblestate_of_int n =
	if n=glut_VISIBLE then VISIBLE else
	if n=glut_NOT_VISIBLE then NOT_VISIBLE else
	raise Failure "visiblestate_of_int"
(* Window status  state. *)                 
val glut_HIDDEN				= def_GLUT_HIDDEN					() 
val glut_FULLY_RETAINED		= def_GLUT_FULLY_RETAINED			() 
val glut_PARTIALLY_RETAINED	= def_GLUT_PARTIALLY_RETAINED		() 
val glut_FULLY_COVERED		= def_GLUT_FULLY_COVERED			() 
type windowstatus = HIDDEN | FULLY_RETAINED | PARTIALLY_RETAINED | FULLY_COVERED
fun windowstatus_to_int HIDDEN = glut_HIDDEN
|	windowstatus_to_int FULLY_RETAINED = glut_FULLY_RETAINED
|	windowstatus_to_int PARTIALLY_RETAINED = glut_PARTIALLY_RETAINED
|	windowstatus_to_int FULLY_COVERED = glut_FULLY_COVERED
fun windowstatus_of_int n =
	if n=glut_HIDDEN then HIDDEN else
	if n=glut_FULLY_RETAINED then FULLY_RETAINED else
	if n=glut_PARTIALLY_RETAINED then PARTIALLY_RETAINED else
	if n=glut_FULLY_COVERED then FULLY_COVERED else
	raise Failure "windowstatus_of_int"
(* Color index component selection vals. *)
val glut_RED	 = def_GLUT_RED						() 
val glut_GREEN	 = def_GLUT_GREEN					() 
val glut_BLUE	 = def_GLUT_BLUE					() 
type colorcomponent = RED | GREEN | BLUE
fun colorcomponent_to_int RED = glut_RED
|	colorcomponent_to_int GREEN = glut_GREEN
|	colorcomponent_to_int BLUE = glut_BLUE
fun colorcomponent_of_int n =
	if n=glut_RED then RED else
	if n=glut_BLUE then BLUE else
	if n=glut_GREEN then GREEN else
	raise Failure "colorcomponent_of_int"
(* Layers for use. *) (* glutUseLayer parameters. *)
val glut_NORMAL  = def_GLUT_NORMAL					() 
val glut_OVERLAY = def_GLUT_OVERLAY					() 
type enumlayer = NORMAL | OVERLAY
fun enumlayer_to_int NORMAL = glut_NORMAL
|	enumlayer_to_int OVERLAY = glut_OVERLAY
fun enumlayer_of_int n =
	if n=glut_NORMAL then NORMAL else
	if n=glut_OVERLAY then OVERLAY else
	raise Failure "enumlayer_of_int"
(* Stroke font constants (use these in glut program). *)
val glut_STROKE_ROMAN	   = def_GLUT_STROKE_ROMAN				() 
val glut_STROKE_MONO_ROMAN = def_GLUT_STROKE_MONO_ROMAN			() 
type strokefont = STROKE_ROMAN | STROKE_MONO_ROMAN
fun strokefont_to_int STROKE_ROMAN = glut_STROKE_ROMAN
|	strokefont_to_int STROKE_MONO_ROMAN = glut_STROKE_MONO_ROMAN
fun strokefont_of_int n =
	if n=glut_STROKE_ROMAN then STROKE_ROMAN else
	if n=glut_STROKE_MONO_ROMAN then STROKE_MONO_ROMAN else
	raise Failure "strokefont_of_int"
(* Bitmap font constants (use these in glut program). *)
val glut_BITMAP_9_BY_15			 = def_GLUT_BITMAP_9_BY_15			() 
val glut_BITMAP_8_BY_13			 = def_GLUT_BITMAP_8_BY_13			() 
val glut_BITMAP_TIMES_ROMAN_10	 = def_GLUT_BITMAP_TIMES_ROMAN_10		() 
val glut_BITMAP_TIMES_ROMAN_24	 = def_GLUT_BITMAP_TIMES_ROMAN_24		() 
val glut_BITMAP_HELVETICA_10	 = def_GLUT_BITMAP_HELVETICA_10		() 
val glut_BITMAP_HELVETICA_12	 = def_GLUT_BITMAP_HELVETICA_12		() 
val glut_BITMAP_HELVETICA_18	 = def_GLUT_BITMAP_HELVETICA_18		() 
type bitmapfont
	= BITMAP_9_BY_15
	| BITMAP_8_BY_13			
	| BITMAP_TIMES_ROMAN_10	
	| BITMAP_TIMES_ROMAN_24	
	| BITMAP_HELVETICA_10	
	| BITMAP_HELVETICA_12	
	| BITMAP_HELVETICA_18	
fun bitmapfont_to_int BITMAP_9_BY_15 = glut_BITMAP_9_BY_15
|	bitmapfont_to_int BITMAP_8_BY_13 = glut_BITMAP_8_BY_13
|	bitmapfont_to_int BITMAP_TIMES_ROMAN_10	= glut_BITMAP_TIMES_ROMAN_10
|	bitmapfont_to_int BITMAP_TIMES_ROMAN_24	= glut_BITMAP_TIMES_ROMAN_24
|	bitmapfont_to_int BITMAP_HELVETICA_10 = glut_BITMAP_HELVETICA_10
|	bitmapfont_to_int BITMAP_HELVETICA_12 = glut_BITMAP_HELVETICA_12
|	bitmapfont_to_int BITMAP_HELVETICA_18 = glut_BITMAP_HELVETICA_18
fun bitmapfont_of_int n =
	if n=glut_BITMAP_9_BY_15 then BITMAP_9_BY_15 else
	if n=glut_BITMAP_8_BY_13 then BITMAP_8_BY_13 else
	if n=glut_BITMAP_TIMES_ROMAN_10 then BITMAP_TIMES_ROMAN_10 else
	if n=glut_BITMAP_TIMES_ROMAN_24 then BITMAP_TIMES_ROMAN_24 else
	if n=glut_BITMAP_HELVETICA_10 then BITMAP_HELVETICA_10 else
	if n=glut_BITMAP_HELVETICA_12 then BITMAP_HELVETICA_12 else
	if n=glut_BITMAP_HELVETICA_18 then BITMAP_HELVETICA_18 else
	raise Failure "bitmapfont_of_int"
(* glutGet parameters. *)
val glut_WINDOW_X					 = def_GLUT_WINDOW_X					() 
val glut_WINDOW_Y					 = def_GLUT_WINDOW_Y					() 
val glut_WINDOW_WIDTH				 = def_GLUT_WINDOW_WIDTH				() 
val glut_WINDOW_HEIGHT				 = def_GLUT_WINDOW_HEIGHT				() 
val glut_WINDOW_BUFFER_SIZE			 = def_GLUT_WINDOW_BUFFER_SIZE		() 
val glut_WINDOW_STENCIL_SIZE		 = def_GLUT_WINDOW_STENCIL_SIZE		() 
val glut_WINDOW_DEPTH_SIZE			 = def_GLUT_WINDOW_DEPTH_SIZE			() 
val glut_WINDOW_RED_SIZE			 = def_GLUT_WINDOW_RED_SIZE			() 
val glut_WINDOW_GREEN_SIZE			 = def_GLUT_WINDOW_GREEN_SIZE			() 
val glut_WINDOW_BLUE_SIZE			 = def_GLUT_WINDOW_BLUE_SIZE			() 
val glut_WINDOW_ALPHA_SIZE			 = def_GLUT_WINDOW_ALPHA_SIZE			() 
val glut_WINDOW_ACCUM_RED_SIZE		 = def_GLUT_WINDOW_ACCUM_RED_SIZE		() 
val glut_WINDOW_ACCUM_GREEN_SIZE	 = def_GLUT_WINDOW_ACCUM_GREEN_SIZE	() 
val glut_WINDOW_ACCUM_BLUE_SIZE		 = def_GLUT_WINDOW_ACCUM_BLUE_SIZE	() 
val glut_WINDOW_ACCUM_ALPHA_SIZE	 = def_GLUT_WINDOW_ACCUM_ALPHA_SIZE	() 
val glut_WINDOW_DOUBLEBUFFER		 = def_GLUT_WINDOW_DOUBLEBUFFER		() 
val glut_WINDOW_RGBA				 = def_GLUT_WINDOW_RGBA				() 
val glut_WINDOW_PARENT				 = def_GLUT_WINDOW_PARENT				() 
val glut_WINDOW_NUM_CHILDREN		 = def_GLUT_WINDOW_NUM_CHILDREN		() 
val glut_WINDOW_COLORMAP_SIZE		 = def_GLUT_WINDOW_COLORMAP_SIZE		() 
val glut_WINDOW_NUM_SAMPLES			 = def_GLUT_WINDOW_NUM_SAMPLES		() 
val glut_WINDOW_STEREO				 = def_GLUT_WINDOW_STEREO				() 
val glut_WINDOW_CURSOR				 = def_GLUT_WINDOW_CURSOR				() 
val glut_SCREEN_WIDTH				 = def_GLUT_SCREEN_WIDTH				() 
val glut_SCREEN_HEIGHT				 = def_GLUT_SCREEN_HEIGHT				() 
val glut_SCREEN_WIDTH_MM			 = def_GLUT_SCREEN_WIDTH_MM			() 
val glut_SCREEN_HEIGHT_MM			 = def_GLUT_SCREEN_HEIGHT_MM			() 
val glut_MENU_NUM_ITEMS				 = def_GLUT_MENU_NUM_ITEMS			() 
val glut_DISPLAY_MODE_POSSIBLE		 = def_GLUT_DISPLAY_MODE_POSSIBLE		() 
val glut_INIT_WINDOW_X				 = def_GLUT_INIT_WINDOW_X				() 
val glut_INIT_WINDOW_Y				 = def_GLUT_INIT_WINDOW_Y				() 
val glut_INIT_WINDOW_WIDTH			 = def_GLUT_INIT_WINDOW_WIDTH			() 
val glut_INIT_WINDOW_HEIGHT			 = def_GLUT_INIT_WINDOW_HEIGHT		() 
val glut_INIT_DISPLAY_MODE			 = def_GLUT_INIT_DISPLAY_MODE			() 
val glut_ELAPSED_TIME				 = def_GLUT_ELAPSED_TIME				() 
val glut_WINDOW_FORMAT_ID			 = def_GLUT_WINDOW_FORMAT_ID			()
type getparam
	= WINDOW_X				
	| WINDOW_Y				
	| WINDOW_WIDTH			
	| WINDOW_HEIGHT			
	| WINDOW_BUFFER_SIZE		
	| WINDOW_STENCIL_SIZE	
	| WINDOW_DEPTH_SIZE		
	| WINDOW_RED_SIZE		
	| WINDOW_GREEN_SIZE		
	| WINDOW_BLUE_SIZE		
	| WINDOW_ALPHA_SIZE		
	| WINDOW_ACCUM_RED_SIZE	
	| WINDOW_ACCUM_GREEN_SIZE
	| WINDOW_ACCUM_BLUE_SIZE	
	| WINDOW_ACCUM_ALPHA_SIZE
	| WINDOW_DOUBLEBUFFER	
	| WINDOW_RGBA			
	| WINDOW_PARENT			
	| WINDOW_NUM_CHILDREN	
	| WINDOW_COLORMAP_SIZE	
	| WINDOW_NUM_SAMPLES		
	| WINDOW_STEREO			
	| WINDOW_CURSOR			
	| SCREEN_WIDTH			
	| SCREEN_HEIGHT			
	| SCREEN_WIDTH_MM		
	| SCREEN_HEIGHT_MM		
	| MENU_NUM_ITEMS			
	| DISPLAY_MODE_POSSIBLE	
	| INIT_WINDOW_X			
	| INIT_WINDOW_Y			
	| INIT_WINDOW_WIDTH		
	| INIT_WINDOW_HEIGHT		
	| INIT_DISPLAY_MODE		
	| ELAPSED_TIME			
	| WINDOW_FORMAT_ID
fun getparam_to_int WINDOW_X					 = 		 glut_WINDOW_X				
|	getparam_to_int WINDOW_Y					 =       glut_WINDOW_Y				
|	getparam_to_int WINDOW_WIDTH				 =       glut_WINDOW_WIDTH			
|	getparam_to_int WINDOW_HEIGHT				 =       glut_WINDOW_HEIGHT			
|	getparam_to_int WINDOW_BUFFER_SIZE			 =       glut_WINDOW_BUFFER_SIZE	
|	getparam_to_int WINDOW_STENCIL_SIZE	    	 =       glut_WINDOW_STENCIL_SIZE	
|	getparam_to_int WINDOW_DEPTH_SIZE			 =       glut_WINDOW_DEPTH_SIZE		
|	getparam_to_int WINDOW_RED_SIZE		    	 =       glut_WINDOW_RED_SIZE		
|	getparam_to_int WINDOW_GREEN_SIZE			 =       glut_WINDOW_GREEN_SIZE		
|	getparam_to_int WINDOW_BLUE_SIZE			 =       glut_WINDOW_BLUE_SIZE		
|	getparam_to_int WINDOW_ALPHA_SIZE			 =       glut_WINDOW_ALPHA_SIZE		
|	getparam_to_int WINDOW_ACCUM_RED_SIZE		 =       glut_WINDOW_ACCUM_RED_SIZE	
|	getparam_to_int WINDOW_ACCUM_GREEN_SIZE		 =       glut_WINDOW_ACCUM_GREEN_SIZE
|	getparam_to_int WINDOW_ACCUM_BLUE_SIZE		 = 		 glut_WINDOW_ACCUM_BLUE_SIZE
|	getparam_to_int WINDOW_ACCUM_ALPHA_SIZE		 =       glut_WINDOW_ACCUM_ALPHA_SIZE
|	getparam_to_int WINDOW_DOUBLEBUFFER	    	 =       glut_WINDOW_DOUBLEBUFFER	
|	getparam_to_int WINDOW_RGBA			    	 =       glut_WINDOW_RGBA			
|	getparam_to_int WINDOW_PARENT				 =       glut_WINDOW_PARENT			
|	getparam_to_int WINDOW_NUM_CHILDREN	    	 =       glut_WINDOW_NUM_CHILDREN	
|	getparam_to_int WINDOW_COLORMAP_SIZE		 =       glut_WINDOW_COLORMAP_SIZE	
|	getparam_to_int WINDOW_NUM_SAMPLES			 =		 glut_WINDOW_NUM_SAMPLES	
|	getparam_to_int WINDOW_STEREO				 =       glut_WINDOW_STEREO			
|	getparam_to_int WINDOW_CURSOR				 =       glut_WINDOW_CURSOR			
|	getparam_to_int SCREEN_WIDTH				 =       glut_SCREEN_WIDTH			
|	getparam_to_int SCREEN_HEIGHT				 =       glut_SCREEN_HEIGHT			
|	getparam_to_int SCREEN_WIDTH_MM		    	 =       glut_SCREEN_WIDTH_MM		
|	getparam_to_int SCREEN_HEIGHT_MM			 =       glut_SCREEN_HEIGHT_MM		
|	getparam_to_int MENU_NUM_ITEMS				 =		 glut_MENU_NUM_ITEMS		
|	getparam_to_int DISPLAY_MODE_POSSIBLE		 =       glut_DISPLAY_MODE_POSSIBLE	
|	getparam_to_int INIT_WINDOW_X				 =       glut_INIT_WINDOW_X			
|	getparam_to_int INIT_WINDOW_Y				 =       glut_INIT_WINDOW_Y			
|	getparam_to_int INIT_WINDOW_WIDTH			 =       glut_INIT_WINDOW_WIDTH		
|	getparam_to_int INIT_WINDOW_HEIGHT			 =   	 glut_INIT_WINDOW_HEIGHT	                                       
|	getparam_to_int INIT_DISPLAY_MODE			 =       glut_INIT_DISPLAY_MODE		
|	getparam_to_int ELAPSED_TIME				 =       glut_ELAPSED_TIME			
|	getparam_to_int WINDOW_FORMAT_ID			 =       glut_WINDOW_FORMAT_ID		

(* glutDeviceGet parameters. *)             
val glut_HAS_KEYBOARD				 = def_GLUT_HAS_KEYBOARD				() 
val glut_HAS_MOUSE					 = def_GLUT_HAS_MOUSE					() 
val glut_HAS_SPACEBALL				 = def_GLUT_HAS_SPACEBALL				() 
val glut_HAS_DIAL_AND_BUTTON_BOX	 = def_GLUT_HAS_DIAL_AND_BUTTON_BOX	() 
val glut_HAS_TABLET					 = def_GLUT_HAS_TABLET				() 
val glut_NUM_MOUSE_BUTTONS			 = def_GLUT_NUM_MOUSE_BUTTONS			() 
val glut_NUM_SPACEBALL_BUTTONS		 = def_GLUT_NUM_SPACEBALL_BUTTONS		() 
val glut_NUM_BUTTON_BOX_BUTTONS		 = def_GLUT_NUM_BUTTON_BOX_BUTTONS	() 
val glut_NUM_DIALS					 = def_GLUT_NUM_DIALS					() 
val glut_NUM_TABLET_BUTTONS			 = def_GLUT_NUM_TABLET_BUTTONS		() 
val glut_DEVICE_IGNORE_KEY_REPEAT	 = def_GLUT_DEVICE_IGNORE_KEY_REPEAT	() 
val glut_DEVICE_KEY_REPEAT			 = def_GLUT_DEVICE_KEY_REPEAT			() 
val glut_HAS_JOYSTICK				 = def_GLUT_HAS_JOYSTICK				() 
val glut_OWNS_JOYSTICK				 = def_GLUT_OWNS_JOYSTICK				() 
val glut_JOYSTICK_BUTTONS			 = def_GLUT_JOYSTICK_BUTTONS			() 
val glut_JOYSTICK_AXES				 = def_GLUT_JOYSTICK_AXES				() 
val glut_JOYSTICK_POLL_RATE			 = def_GLUT_JOYSTICK_POLL_RATE		() 
type devicegetparam
	= HAS_KEYBOARD			
	| HAS_MOUSE				
	| HAS_SPACEBALL				
	| HAS_DIAL_AND_BUTTON_BOX
	| HAS_TABLET			 
	| NUM_MOUSE_BUTTONS		 
	| NUM_SPACEBALL_BUTTONS	 
	| NUM_BUTTON_BOX_BUTTONS 
	| NUM_DIALS				 
	| NUM_TABLET_BUTTONS	 
	| DEVICE_IGNORE_KEY_REPEAT	
	| DEVICE_KEY_REPEAT		
	| HAS_JOYSTICK			
	| OWNS_JOYSTICK			
	| JOYSTICK_BUTTONS		
	| JOYSTICK_AXES			
	| JOYSTICK_POLL_RATE	
fun devicegetparam_to_int HAS_KEYBOARD				= glut_HAS_KEYBOARD			
|	devicegetparam_to_int HAS_MOUSE					= glut_HAS_MOUSE				
|	devicegetparam_to_int HAS_SPACEBALL				= glut_HAS_SPACEBALL			
|	devicegetparam_to_int HAS_DIAL_AND_BUTTON_BOX	= glut_HAS_DIAL_AND_BUTTON_BOX	
|	devicegetparam_to_int HAS_TABLET			 	= glut_HAS_TABLET				
|	devicegetparam_to_int NUM_MOUSE_BUTTONS			= glut_NUM_MOUSE_BUTTONS		
|	devicegetparam_to_int NUM_SPACEBALL_BUTTONS		= glut_NUM_SPACEBALL_BUTTONS	
|	devicegetparam_to_int NUM_BUTTON_BOX_BUTTONS	= glut_NUM_BUTTON_BOX_BUTTONS	
|	devicegetparam_to_int NUM_DIALS					= glut_NUM_DIALS				
|	devicegetparam_to_int NUM_TABLET_BUTTONS		= glut_NUM_TABLET_BUTTONS		
|	devicegetparam_to_int DEVICE_IGNORE_KEY_REPEAT	= glut_DEVICE_IGNORE_KEY_REPEAT
|	devicegetparam_to_int DEVICE_KEY_REPEAT			= glut_DEVICE_KEY_REPEAT		
|	devicegetparam_to_int HAS_JOYSTICK				= glut_HAS_JOYSTICK			
|	devicegetparam_to_int OWNS_JOYSTICK				= glut_OWNS_JOYSTICK			
|	devicegetparam_to_int JOYSTICK_BUTTONS			= glut_JOYSTICK_BUTTONS		
|	devicegetparam_to_int JOYSTICK_AXES				= glut_JOYSTICK_AXES			
|	devicegetparam_to_int JOYSTICK_POLL_RATE		= glut_JOYSTICK_POLL_RATE		

(* glutLayerGet parameters. *)
val glut_OVERLAY_POSSIBLE	 = def_GLUT_OVERLAY_POSSIBLE		() 
val glut_LAYER_IN_USE		 = def_GLUT_LAYER_IN_USE			() 
val glut_HAS_OVERLAY		 = def_GLUT_HAS_OVERLAY				() 
val glut_TRANSPARENT_INDEX	 = def_GLUT_TRANSPARENT_INDEX		() 
val glut_NORMAL_DAMAGED		 = def_GLUT_NORMAL_DAMAGED			() 
val glut_OVERLAY_DAMAGED	 = def_GLUT_OVERLAY_DAMAGED			()
type layergetparam
	= OVERLAY_POSSIBLE	
	| LAYER_IN_USE		
	| HAS_OVERLAY		
	| TRANSPARENT_INDEX	
	| NORMAL_DAMAGED	
	| OVERLAY_DAMAGED	
fun layergetparam_to_int OVERLAY_POSSIBLE		= glut_OVERLAY_POSSIBLE	
|	layergetparam_to_int LAYER_IN_USE		    = glut_LAYER_IN_USE		
|	layergetparam_to_int HAS_OVERLAY		    = glut_HAS_OVERLAY		
|	layergetparam_to_int TRANSPARENT_INDEX	    = glut_TRANSPARENT_INDEX
|	layergetparam_to_int NORMAL_DAMAGED		    = glut_NORMAL_DAMAGED		
|	layergetparam_to_int OVERLAY_DAMAGED	    = glut_OVERLAY_DAMAGED	

(* glutVideoResizeGet parameters. *)        
val glut_VIDEO_RESIZE_POSSIBLE		 = def_GLUT_VIDEO_RESIZE_POSSIBLE		() 
val glut_VIDEO_RESIZE_IN_USE		 = def_GLUT_VIDEO_RESIZE_IN_USE			() 
val glut_VIDEO_RESIZE_X_DELTA		 = def_GLUT_VIDEO_RESIZE_X_DELTA		() 
val glut_VIDEO_RESIZE_Y_DELTA		 = def_GLUT_VIDEO_RESIZE_Y_DELTA		() 
val glut_VIDEO_RESIZE_WIDTH_DELTA	 = def_GLUT_VIDEO_RESIZE_WIDTH_DELTA	() 
val glut_VIDEO_RESIZE_HEIGHT_DELTA	 = def_GLUT_VIDEO_RESIZE_HEIGHT_DELTA	() 
val glut_VIDEO_RESIZE_X				 = def_GLUT_VIDEO_RESIZE_X				() 
val glut_VIDEO_RESIZE_Y				 = def_GLUT_VIDEO_RESIZE_Y				() 
val glut_VIDEO_RESIZE_WIDTH			 = def_GLUT_VIDEO_RESIZE_WIDTH			() 
val glut_VIDEO_RESIZE_HEIGHT		 = def_GLUT_VIDEO_RESIZE_HEIGHT			() 
type videoresize
	= VIDEO_RESIZE_POSSIBLE		
	| VIDEO_RESIZE_IN_USE		
	| VIDEO_RESIZE_X_DELTA		
	| VIDEO_RESIZE_Y_DELTA		
	| VIDEO_RESIZE_WIDTH_DELTA	
	| VIDEO_RESIZE_HEIGHT_DELTA	
	| VIDEO_RESIZE_X				
	| VIDEO_RESIZE_Y				
	| VIDEO_RESIZE_WIDTH			
	| VIDEO_RESIZE_HEIGHT		
fun videoresize_to_int VIDEO_RESIZE_POSSIBLE	= glut_VIDEO_RESIZE_POSSIBLE
|	videoresize_to_int VIDEO_RESIZE_IN_USE		= glut_VIDEO_RESIZE_IN_USE
|	videoresize_to_int VIDEO_RESIZE_X_DELTA		= glut_VIDEO_RESIZE_X_DELTA
|	videoresize_to_int VIDEO_RESIZE_Y_DELTA		= glut_VIDEO_RESIZE_Y_DELTA
|	videoresize_to_int VIDEO_RESIZE_WIDTH_DELTA	= glut_VIDEO_RESIZE_WIDTH_DELTA
|	videoresize_to_int VIDEO_RESIZE_HEIGHT_DELTA= glut_VIDEO_RESIZE_HEIGHT_DELTA
|	videoresize_to_int VIDEO_RESIZE_X			= glut_VIDEO_RESIZE_X
|	videoresize_to_int VIDEO_RESIZE_Y			= glut_VIDEO_RESIZE_Y
|	videoresize_to_int VIDEO_RESIZE_WIDTH		= glut_VIDEO_RESIZE_WIDTH
|	videoresize_to_int VIDEO_RESIZE_HEIGHT		= glut_VIDEO_RESIZE_HEIGHT

(* glutGetModifiers return mask. *)         
val glut_ACTIVE_SHIFT	 = def_GLUT_ACTIVE_SHIFT			() 
val glut_ACTIVE_CTRL	 = def_GLUT_ACTIVE_CTRL				() 
val glut_ACTIVE_ALT		 = def_GLUT_ACTIVE_ALT				() 
type getmodifiersreturn
	= ACTIVE_SHIFT	
	| ACTIVE_CTRL	
	| ACTIVE_ALT		
fun getmodifiersreturn_to_int ACTIVE_SHIFT = glut_ACTIVE_SHIFT
|	getmodifiersreturn_to_int ACTIVE_CTRL = glut_ACTIVE_CTRL
|	getmodifiersreturn_to_int ACTIVE_ALT = glut_ACTIVE_ALT
fun getmodifiersreturn_of_int n =
	if n=glut_ACTIVE_SHIFT	then ACTIVE_SHIFT else
	if n=glut_ACTIVE_CTRL	then ACTIVE_CTRL else
	if n=glut_ACTIVE_ALT	then ACTIVE_ALT else
	raise Failure "Glut.getmodifiersreturn_of_int"
                                            
(* glutSetCursor parameters. *)             
(* Basic arrows. *)                         
val glut_CURSOR_RIGHT_ARROW			 = def_GLUT_CURSOR_RIGHT_ARROW			() 
val glut_CURSOR_LEFT_ARROW			 = def_GLUT_CURSOR_LEFT_ARROW	  		() 
(* Symbolic cursor shapes. *)                                             
val glut_CURSOR_INFO				 = def_GLUT_CURSOR_INFO			  		() 
val glut_CURSOR_DESTROY				 = def_GLUT_CURSOR_DESTROY		  		() 
val glut_CURSOR_HELP				 = def_GLUT_CURSOR_HELP			  		() 
val glut_CURSOR_CYCLE				 = def_GLUT_CURSOR_CYCLE		  		() 
val glut_CURSOR_SPRAY				 = def_GLUT_CURSOR_SPRAY		  		() 
val glut_CURSOR_WAIT				 = def_GLUT_CURSOR_WAIT			  		() 
val glut_CURSOR_TEXT				 = def_GLUT_CURSOR_TEXT			  		() 
val glut_CURSOR_CROSSHAIR			 = def_GLUT_CURSOR_CROSSHAIR	  		() 
(* Directional cursors. *)                                                
val glut_CURSOR_UP_DOWN				 = def_GLUT_CURSOR_UP_DOWN		  		() 
val glut_CURSOR_LEFT_RIGHT			 = def_GLUT_CURSOR_LEFT_RIGHT	  		() 
(* Sizing cursors. *)                                                     
val glut_CURSOR_TOP_SIDE			 = def_GLUT_CURSOR_TOP_SIDE		  		() 
val glut_CURSOR_BOTTOM_SIDE			 = def_GLUT_CURSOR_BOTTOM_SIDE			() 
val glut_CURSOR_LEFT_SIDE			 = def_GLUT_CURSOR_LEFT_SIDE	  		() 
val glut_CURSOR_RIGHT_SIDE			 = def_GLUT_CURSOR_RIGHT_SIDE	  		() 
val glut_CURSOR_TOP_LEFT_CORNER		 = def_GLUT_CURSOR_TOP_LEFT_CORNER		() 
val glut_CURSOR_TOP_RIGHT_CORNER	 = def_GLUT_CURSOR_TOP_RIGHT_CORNER		() 
val glut_CURSOR_BOTTOM_RIGHT_CORNER	 = def_GLUT_CURSOR_BOTTOM_RIGHT_CORNER	() 
val glut_CURSOR_BOTTOM_LEFT_CORNER	 = def_GLUT_CURSOR_BOTTOM_LEFT_CORNER	() 
(* Inherit from parent window. *)           
val glut_CURSOR_INHERIT				 = def_GLUT_CURSOR_INHERIT				() 
(* Blank cursor. *)                         
val glut_CURSOR_NONE				 = def_GLUT_CURSOR_NONE					() 
(* Fullscreen crosshair (if available). *)  
val glut_CURSOR_FULL_CROSSHAIR		 = def_GLUT_CURSOR_FULL_CROSSHAIR		() 
type cursorimage
	= CURSOR_RIGHT_ARROW			
	| CURSOR_LEFT_ARROW			
	| CURSOR_INFO				
	| CURSOR_DESTROY				
	| CURSOR_HELP				
	| CURSOR_CYCLE				
	| CURSOR_SPRAY				
	| CURSOR_WAIT				
	| CURSOR_TEXT				
	| CURSOR_CROSSHAIR			
	| CURSOR_UP_DOWN				
	| CURSOR_LEFT_RIGHT			
	| CURSOR_TOP_SIDE			
	| CURSOR_BOTTOM_SIDE			
	| CURSOR_LEFT_SIDE			
	| CURSOR_RIGHT_SIDE			
	| CURSOR_TOP_LEFT_CORNER		
	| CURSOR_TOP_RIGHT_CORNER	
	| CURSOR_BOTTOM_RIGHT_CORNER	
	| CURSOR_BOTTOM_LEFT_CORNER	
	| CURSOR_INHERIT				
	| CURSOR_NONE				
	| CURSOR_FULL_CROSSHAIR		
fun cursorimage_to_int CURSOR_RIGHT_ARROW			= glut_CURSOR_RIGHT_ARROW			
|	cursorimage_to_int CURSOR_LEFT_ARROW			= glut_CURSOR_LEFT_ARROW			
|	cursorimage_to_int CURSOR_INFO					= glut_CURSOR_INFO				
|	cursorimage_to_int CURSOR_DESTROY				= glut_CURSOR_DESTROY				
|	cursorimage_to_int CURSOR_HELP					= glut_CURSOR_HELP				
|	cursorimage_to_int CURSOR_CYCLE					= glut_CURSOR_CYCLE				
|	cursorimage_to_int CURSOR_SPRAY					= glut_CURSOR_SPRAY				
|	cursorimage_to_int CURSOR_WAIT					= glut_CURSOR_WAIT				
|	cursorimage_to_int CURSOR_TEXT					= glut_CURSOR_TEXT				
|	cursorimage_to_int CURSOR_CROSSHAIR				= glut_CURSOR_CROSSHAIR			
|	cursorimage_to_int CURSOR_UP_DOWN				= glut_CURSOR_UP_DOWN				
|	cursorimage_to_int CURSOR_LEFT_RIGHT			= glut_CURSOR_LEFT_RIGHT			
|	cursorimage_to_int CURSOR_TOP_SIDE				= glut_CURSOR_TOP_SIDE			
|	cursorimage_to_int CURSOR_BOTTOM_SIDE			= glut_CURSOR_BOTTOM_SIDE			
|	cursorimage_to_int CURSOR_LEFT_SIDE				= glut_CURSOR_LEFT_SIDE			
|	cursorimage_to_int CURSOR_RIGHT_SIDE			= glut_CURSOR_RIGHT_SIDE			
|	cursorimage_to_int CURSOR_TOP_LEFT_CORNER		= glut_CURSOR_TOP_LEFT_CORNER		
|	cursorimage_to_int CURSOR_TOP_RIGHT_CORNER		= glut_CURSOR_TOP_RIGHT_CORNER	
|	cursorimage_to_int CURSOR_BOTTOM_RIGHT_CORNER	= glut_CURSOR_BOTTOM_RIGHT_CORNER	
|	cursorimage_to_int CURSOR_BOTTOM_LEFT_CORNER	= glut_CURSOR_BOTTOM_LEFT_CORNER	
|	cursorimage_to_int CURSOR_INHERIT				= glut_CURSOR_INHERIT				
|	cursorimage_to_int CURSOR_NONE					= glut_CURSOR_NONE				
|	cursorimage_to_int CURSOR_FULL_CROSSHAIR		= glut_CURSOR_FULL_CROSSHAIR		

(* glutSetKeyRepeat modes. *)               
val glut_KEY_REPEAT_OFF				 = def_GLUT_KEY_REPEAT_OFF			() 
val glut_KEY_REPEAT_ON				 = def_GLUT_KEY_REPEAT_ON			() 
val glut_KEY_REPEAT_DEFAULT			 = def_GLUT_KEY_REPEAT_DEFAULT		()
type keyrepeatmode
	= KEY_REPEAT_OFF
	| KEY_REPEAT_ON
	| KEY_REPEAT_DEFAULT
fun keyrepeatmode_to_int KEY_REPEAT_OFF = glut_KEY_REPEAT_OFF
|	keyrepeatmode_to_int KEY_REPEAT_ON = glut_KEY_REPEAT_ON
|	keyrepeatmode_to_int KEY_REPEAT_DEFAULT = glut_KEY_REPEAT_DEFAULT
(* Joystick button masks. *)
val glut_JOYSTICK_BUTTON_A			 = def_GLUT_JOYSTICK_BUTTON_A			() 
val glut_JOYSTICK_BUTTON_B			 = def_GLUT_JOYSTICK_BUTTON_B			() 
val glut_JOYSTICK_BUTTON_C			 = def_GLUT_JOYSTICK_BUTTON_C			() 
val glut_JOYSTICK_BUTTON_D			 = def_GLUT_JOYSTICK_BUTTON_D			()
type joystickbutton
	= JOYSTICK_BUTTON_A
	| JOYSTICK_BUTTON_B
	| JOYSTICK_BUTTON_C
	| JOYSTICK_BUTTON_D
fun joystickbutton_to_int JOYSTICK_BUTTON_A = def_GLUT_JOYSTICK_BUTTON_A()
|	joystickbutton_to_int JOYSTICK_BUTTON_B = def_GLUT_JOYSTICK_BUTTON_B()
|	joystickbutton_to_int JOYSTICK_BUTTON_C = def_GLUT_JOYSTICK_BUTTON_C()
|	joystickbutton_to_int JOYSTICK_BUTTON_D = def_GLUT_JOYSTICK_BUTTON_D()
fun joystickbutton_of_int n =
	if n=glut_JOYSTICK_BUTTON_A then JOYSTICK_BUTTON_A else
	if n=glut_JOYSTICK_BUTTON_B then JOYSTICK_BUTTON_B else
	if n=glut_JOYSTICK_BUTTON_C then JOYSTICK_BUTTON_C else
	if n=glut_JOYSTICK_BUTTON_D then JOYSTICK_BUTTON_D else
	raise Failure "joystickbutton_of_int"

(* glutGameModeGet. *)                      
val glut_GAME_MODE_ACTIVE			 = def_GLUT_GAME_MODE_ACTIVE			() 
val glut_GAME_MODE_POSSIBLE			 = def_GLUT_GAME_MODE_POSSIBLE			() 
val glut_GAME_MODE_WIDTH			 = def_GLUT_GAME_MODE_WIDTH				() 
val glut_GAME_MODE_HEIGHT			 = def_GLUT_GAME_MODE_HEIGHT			() 
val glut_GAME_MODE_PIXEL_DEPTH		 = def_GLUT_GAME_MODE_PIXEL_DEPTH		() 
val glut_GAME_MODE_REFRESH_RATE		 = def_GLUT_GAME_MODE_REFRESH_RATE		() 
val glut_GAME_MODE_DISPLAY_CHANGED	 = def_GLUT_GAME_MODE_DISPLAY_CHANGED	()
type gamemode
	= GAME_MODE_ACTIVE		  
	| GAME_MODE_POSSIBLE		  
	| GAME_MODE_WIDTH		  
	| GAME_MODE_HEIGHT		  
	| GAME_MODE_PIXEL_DEPTH	  
	| GAME_MODE_REFRESH_RATE	  
	| GAME_MODE_DISPLAY_CHANGED
fun gamemode_to_int GAME_MODE_ACTIVE			= glut_GAME_MODE_ACTIVE
|	gamemode_to_int GAME_MODE_POSSIBLE			= glut_GAME_MODE_POSSIBLE
|	gamemode_to_int GAME_MODE_WIDTH		  		= glut_GAME_MODE_WIDTH
|	gamemode_to_int GAME_MODE_HEIGHT			= glut_GAME_MODE_HEIGHT
|	gamemode_to_int GAME_MODE_PIXEL_DEPTH		= glut_GAME_MODE_PIXEL_DEPTH
|	gamemode_to_int GAME_MODE_REFRESH_RATE		= glut_GAME_MODE_REFRESH_RATE
|	gamemode_to_int GAME_MODE_DISPLAY_CHANGED	= glut_GAME_MODE_DISPLAY_CHANGED

(* GLUT initialization sub-API. *)
fun init argv = Glut_.init (Array.length argv) argv
fun initDisplayMode dml =
	let	fun dm_to_ni dm = Nativeint.of_int(displaymode_to_int dm)
		val ni = List.fold_left
					Nativeint.logor	Nativeint.zero (List.map dm_to_ni dml)
	in	Glut_.initDisplayMode (Nativeint.to_int ni) end
val initDisplayString = initDisplayString
val initWindowPosition = initWindowPosition
val initWindowSize = initWindowSize
val mainLoop = mainLoop

(* GLUT window sub-API. *)
type windowidentifier = WIN of int
fun createWindow str = WIN(Glut_.createWindow str)
fun createSubWindow (WIN w) x y width height = WIN(Glut_.createSubWindow w x y width height) 
fun destroyWindow (WIN w) = Glut_.destroyWindow w 
val postRedisplay = postRedisplay
val postWindowRedisplay = postWindowRedisplay
val swapBuffers = swapBuffers
fun getWindow u = WIN(Glut_.getWindow u) 
fun setWindow (WIN w) = Glut_.setWindow w
val setWindowTitle = setWindowTitle
val setIconTitle = setIconTitle
val positionWindow = positionWindow
val reshapeWindow = reshapeWindow
val popWindow = popWindow
val pushWindow = pushWindow
val iconifyWindow = iconifyWindow
val showWindow = showWindow
val hideWindow = hideWindow
val fullScreen = fullScreen
fun setCursor ci = Glut_.setCursor(cursorimage_to_int ci)
val warpPointer = warpPointer

(* GLUT overlay sub-API. *)
val establishOverlay = establishOverlay
val removeOverlay = removeOverlay
fun useLayer e = Glut_.useLayer(enumlayer_to_int e)
val postOverlayRedisplay = postOverlayRedisplay
fun postWindowOverlayRedisplay (WIN w) = Glut_.postWindowOverlayRedisplay w
val showOverlay = showOverlay
val hideOverlay = hideOverlay

(* GLUT menu sub-API. *)
type menuidentifier = MENU of int
fun createMenu f = MENU(Glut_.createMenu f)
fun destroyMenu (MENU n) = Glut_.destroyMenu n
fun getMenu u = MENU(Glut_.getMenu u)
fun setMenu (MENU n) = Glut_.setMenu n
val addMenuEntry = addMenuEntry
fun addSubMenu str (MENU n) = Glut_.addSubMenu str n
val changeToMenuEntry = changeToMenuEntry
fun changeToSubMenu k str (MENU n) = Glut_.changeToSubMenu k str n
val removeMenuItem = removeMenuItem
fun attachMenu bt = Glut_.attachMenu(mousebutton_to_int bt)
fun detachMenu bt = Glut_.detachMenu(mousebutton_to_int bt)
 
(* GLUT window callback sub-API. *)
val displayFunc = displayFunc
val reshapeFunc = reshapeFunc
val keyboardFunc = keyboardFunc
fun mouseFunc f =
	Glut_.mouseFunc
		(fn b=>fn s=>fn x=> fn y=>
			f (mousebutton_of_int b) (mousebuttonstate_of_int s) x y)
val motionFunc = motionFunc
val passiveMotionFunc = passiveMotionFunc
fun entryFunc f = Glut_.entryFunc(fn x=>f(entrystate_of_int x))
fun visibilityFunc f = Glut_.visibilityFunc(fn x=>f(visiblestate_of_int x))
val idleFunc = idleFunc
val timerFunc = timerFunc
fun menuStateFunc f = Glut_.menuStateFunc(fn x=>f(menustate_of_int x))
fun specialFunc f = Glut_.specialFunc(fn x=>f(specialkey_of_int x))
val spaceballMotionFunc = spaceballMotionFunc
val spaceballRotateFunc = spaceballRotateFunc
fun spaceballButtonFunc f =
	Glut_.spaceballButtonFunc
		(fn b=>fn s=>f (mousebutton_of_int b) (mousebuttonstate_of_int s)) 
fun buttonBoxFunc f =
	Glut_.buttonBoxFunc
		(fn b=>fn s=>f (mousebutton_of_int b) (mousebuttonstate_of_int s))
val dialsFunc = dialsFunc
val tabletMotionFunc = tabletMotionFunc
fun tabletButtonFunc f =
	Glut_.tabletButtonFunc
		(fn b=>fn s=>fn x=> fn y=>
			f (mousebutton_of_int b) (mousebuttonstate_of_int s) x y)
fun menuStatusFunc f =
	Glut_.menuStatusFunc(fn s=>fn x=>fn y=>f (menustate_of_int s) x  y)
val overlayDisplayFunc = overlayDisplayFunc
fun windowStatusFunc f = Glut_.windowStatusFunc(fn x=>f(windowstatus_of_int x)) 
val keyboardUpFunc = keyboardUpFunc
val specialUpFunc = specialUpFunc
fun joystickFunc f pi =
	Glut_.joystickFunc (fn bm=>fn x=>fn y=>fn z=> f (bm) x y z) pi

(* GLUT color index sub-API. *)
val setColor = setColor
fun getColor ndx cc = Glut_.getColor ndx (colorcomponent_to_int cc)
fun copyColormap (WIN w) = Glut_.copyColormap w

(* GLUT state retrieval sub-API. *)
fun get gp = Glut_.get(getparam_to_int gp)
fun deviceGet dgp = Glut_.deviceGet(devicegetparam_to_int dgp)
(* GLUT extension support sub-API *)
val extensionSupported = extensionSupported
fun getModifiers u = getmodifiersreturn_of_int(Glut_.getModifiers u)
fun layerGet lgp = Glut_.layerGet(layergetparam_to_int lgp)

(* GLUT font sub-API *)
fun bitmapCharacter bf = Glut_.bitmapCharacter (bitmapfont_to_int bf)
fun bitmapWidth bf = Glut_.bitmapWidth (bitmapfont_to_int bf)
fun strokeCharacter sf = Glut_.strokeCharacter (strokefont_to_int sf)
fun strokeWidth sf = Glut_.strokeWidth (strokefont_to_int sf)
fun bitmapLength bf = Glut_.bitmapLength (bitmapfont_to_int bf)
fun strokeLength sf = Glut_.strokeLength (strokefont_to_int sf)

(* GLUT pre-built models sub-API *)
type prebuiltmodeltype = WIRE | SOLID
fun sphere WIRE = wireSphere
|	sphere SOLID = solidSphere
val wireSphere = wireSphere
val solidSphere = solidSphere
fun cone WIRE = wireCone
|	cone SOLID = solidCone
val wireCone = wireCone
val solidCone = solidCone
fun cube WIRE = wireCube
|	cube SOLID = solidCube
val wireCube = wireCube
val solidCube = solidCube
fun torus WIRE = wireTorus
|	torus SOLID = solidTorus
val wireTorus = wireTorus
val solidTorus = solidTorus
fun dodecahedron WIRE = wireDodecahedron
|	dodecahedron SOLID = solidDodecahedron
val wireDodecahedron = wireDodecahedron
val solidDodecahedron = solidDodecahedron
fun teapot WIRE = wireTeapot
|	teapot SOLID = solidTeapot
val wireTeapot = wireTeapot
val solidTeapot = solidTeapot
fun octahedron WIRE = wireOctahedron
|	octahedron SOLID = solidOctahedron
val wireOctahedron = wireOctahedron
val solidOctahedron = solidOctahedron
fun tetrahedron WIRE = wireTetrahedron
|	tetrahedron SOLID = solidTetrahedron
val wireTetrahedron = wireTetrahedron
val solidTetrahedron = solidTetrahedron
fun icosahedron WIRE = wireIcosahedron
|	icosahedron SOLID = solidIcosahedron
val wireIcosahedron = wireIcosahedron
val solidIcosahedron = solidIcosahedron

(* GLUT video resize sub-API. *)
fun videoResizeGet vr = Glut_.videoResizeGet(videoresize_to_int vr)
val setupVideoResizing = setupVideoResizing 
val stopVideoResizing = stopVideoResizing
val videoResize = videoResize
val videoPan = videoPan

(* GLUT debugging sub-API. *)
val reportErrors = reportErrors

(* GLUT device control sub-API. *)
fun ignoreKeyRepeat krm = Glut_.ignoreKeyRepeat(keyrepeatmode_to_int krm)
fun setKeyRepeat kpm = Glut_.setKeyRepeat(keyrepeatmode_to_int kpm)
val forceJoystickFunc = forceJoystickFunc 

(* GLUT game mode sub-API. *)
val gameModeString = gameModeString
val enterGameMode = enterGameMode
val leaveGameMode = leaveGameMode
fun gameModeGet gm = Glut_.gameModeGet(gamemode_to_int gm)

end
