val (angle, theta) = (ref 0.0, ref 0.5)
val smiley = //   bitmap
	"\
	\003\192\000\000\
	\015\240\000\000\
	\030\120\000\000\
	\057\156\000\000\
	\119\238\000\000\
	\111\246\000\000\
	\255\255\000\000\
	\255\255\000\000\
	\255\255\000\000\
	\255\255\000\000\
	\115\206\000\000\
	\115\206\000\000\
	\063\252\000\000\
	\031\248\000\000\
	\015\240\000\000\
	\003\192\000\000\
	"
// torus  material property
val mdi = Array.of_list [1.0,1.0,0.0,1.0] // diffuse
val mam = Array.of_list [1.0,0.0,1.0,1.0] // ambient
val msp = Array.of_list [1.0,1.0,1.0,1.0] // specular
val msh = 128.0                           // shininess : specular exponent

val rainbowtex = ref 0 //  ׸  1D texture  θ
val loadtextures = fn () => // display list  .
	let val roygbiv =
			"\
			\063\000\063\
			\127\000\126\
			\191\000\191\
			\000\000\255\
			\000\255\000\
			\255\255\000\
			\255\127\000\
			\255\000\000\
			"
	in	Gl.newList !rainbowtex Gl.COMPILE ;
			Gl.texParameter Gl.TEXTURE_1D (Gl.MAG_FILTER Gl.LINEAR) ;
			Gl.texParameter Gl.TEXTURE_1D (Gl.MIN_FILTER Gl.LINEAR) ;
			Gl.texParameter Gl.TEXTURE_1D (Gl.WRAP_S Gl.REPEAT) ;
			Gl.texImage1D Gl.TEXTURE_1D 0 4 8 0
						Gl.RGB (Gl.PT Gl.UNSIGNED_BYTE) roygbiv ;
		Gl.endList ()
	end

val doublerainbowcircle = ref 0
val initrainbows = fn () => //    ׸ display list  .
	Gl.newList !doublerainbowcircle Gl.COMPILE ;
	Gl.enable (Gl.TEX Gl.TEXTURE_1D) ;
	Gl.callList !rainbowtex ;
	Gl.glbegin Gl.QUAD_STRIP ;
	let val pi = 3.141592
		fun f n = if n>60 then () else
				let val th = float_of_int n / 30.0 * pi
				in	Gl.texCoord1 0.0 ;
					Gl.vertex3 (85.0 * cos th) (85.0 * sin th) (-42.0) ;
					Gl.texCoord1 1.0 ;
					Gl.vertex3 (105.0 * cos th) (105.0 * sin th) (-42.0) ;
					f (n+1)
				end
	in f 0  end ;
	Gl.glend () ;
	Gl.glbegin Gl.QUAD_STRIP ;
	let val pi = 3.141592
		fun f n = if n>60 then () else
				let val th = float_of_int n / 30.0 * pi
				in	Gl.texCoord1 0.0 ;
					Gl.vertex3 (85.0 * cos th) (85.0 * sin th) (41.0) ;
					Gl.texCoord1 1.0 ;
					Gl.vertex3 (105.0 * cos th) (105.0 * sin th) (41.0) ;
					f (n+1)
				end
	in f 0  end ;
	Gl.glend () ;
	Gl.disable (Gl.TEX Gl.TEXTURE_1D) ;
	Gl.endList ()

val display = fn () =>
	// ȭ 
	Gl.clearColor 0.0 0.0 0.0 1.0 ;
	Gl.clear [Gl.COLOR_BUFFER_BIT,Gl.DEPTH_BUFFER_BIT] ;
	// orthographic projection  clipping volume  
	Gl.matrixMode Gl.PROJECTION ;
	Gl.loadIdentity () ;
	Gl.ortho 0.0 300.0 0.0 300.0 300.0 (-300.0) ;
	// ȸȯ
	Gl.matrixMode Gl.MODELVIEW ;
	Gl.loadIdentity () ;
	Gl.translate 150.0 150.0 0.0 ;
	Gl.rotate !angle 0.0 1.0 0.0 ;
	// Ӽ 
	Gl.materialfv Gl.F_FRONT Gl.M_AMBIENT mam ;
	Gl.materialfv Gl.F_FRONT Gl.M_DIFFUSE mdi ;
	Gl.materialfv Gl.F_FRONT Gl.M_SPECULAR msp ;
	Gl.materialf Gl.F_FRONT Gl.SHININESS msh ;
	// Ѱ ䷯ ׸
	Gl.enable Gl.LIGHTING ;
	Glut.torus Glut.SOLID 40.0 90.0 30 60 ;
	Gl.disable Gl.LIGHTING ;
	//   3  ׸.
	Gl.color3 0.0 1.0 1.0 ;
	Gl.rasterPos2 130.0 130.0 ;
	Gl.bitmap 16 16 8.0 8.0 0.0 0.0 smiley ;
	Gl.rasterPos2 (-130.0) (-130.0) ;
	Gl.bitmap 16 16 8.0 8.0 0.0 0.0 smiley ;
	Gl.rasterPos2 0.0 0.0 ;
	Gl.bitmap 16 16 8.0 8.0 0.0 0.0 smiley ;
	Gl.color3 1.0 1.0 1.0 ;
	//    ׸ display list  ۵Ų.
	Gl.callList !doublerainbowcircle ;
	//     ϰ front  back buffer  ٲ ȭ update
	Gl.flush () ;
	// texture should not run on torus or smiley
	Glut.swapBuffers () ;
	// 1.0 ŭ ȸŲ.
	if !angle < 359.0 then angle += 1.0 else angle := 0.0
	
val initlight = fn () => //  ʱȭѴ.
	let val pos = Array.of_list [15.0,30.0,-45.0,0.0] // position
		val spe = Array.of_list [1.0,1.0,1.0,1.0] // specular
		val dif = Array.of_list [1.0,1.0,1.0,1.0] // diffuse
	in
		Gl.shadeModel Gl.FLAT ;
		Gl.lightfv Gl.LIGHT0 Gl.POSITION pos ;
		Gl.lightfv Gl.LIGHT0 Gl.L_DIFFUSE dif ;
		Gl.lightfv Gl.LIGHT0 Gl.L_SPECULAR spe ;
		Gl.enable Gl.LIGHTING ;
		Gl.enable (Gl.LIGHT Gl.LIGHT0) ;
		Gl.enable Gl.DEPTH_TEST
	end


val mouseexit = fn _ _ _ _ => // Ӹ忡 콺 Ŭϸ â ٲ۴.
	Glut.leaveGameMode () ; theta := 0.5 ;
	Glut.initDisplayMode [Glut.RGBA,Glut.DOUBLE] ;
	Glut.initWindowSize 250 250 ;
	Glut.initWindowPosition 100 100 ;
	Glut.createWindow "Hello GLUT!" ;
	initlight () ;
	loadtextures () ;
	initrainbows () ;
	Glut.displayFunc display ;
	Glut.idleFunc display

val _ = // main procedure ; give any command line option to see game mode
	Glut.init Sys.argv ;
	Glut.initDisplayMode [Glut.RGBA,Glut.DOUBLE] ;
	if Array.length Sys.argv > 1 then Glut.enterGameMode ()
	else
	(	Glut.initWindowSize 450 480 ;
		Glut.initWindowPosition 105 0 ;
		Glut.createWindow "Hello GLUT!" ; 0 ) ;
	initlight () ;
	rainbowtex := Gl.genLists 1 ;
	loadtextures () ;
	doublerainbowcircle := Gl.genLists 1 ;
	initrainbows () ;
	Glut.displayFunc display ;
	Glut.idleFunc display ;
	if Array.length Sys.argv > 1 then Glut.mouseFunc mouseexit else theta:=0.5 ;
	Glut.mainLoop ()
